'
'
'              **************************************
'              |                                    |
'              |   The Track Editor,  version 19    |
'              |                                    |
'              **************************************
'
'                          by Tim Granger
'                      e-mail tjg21@cam.ac.uk
'
'                   Last updated 4 January 1995
'
'            see TRK19.TXT for help with this program
'            (if you havn't got this file, contact me)
'
'        e-mail me with suggestions, bugs, comments, etc...
'
'
'
'
'
DECLARE SUB PrintCol (row!, m$)
DECLARE SUB Scale (scl!)
DECLARE SUB C (xa!, ya!, r!, col!, st!, ed!, asp!)
DECLARE SUB P (xa!, ya!, col!, bcol!)
DECLARE SUB L (xa!, ya!, xb!, yb!, col!, md!)
DECLARE SUB PrintSel (n!)
DECLARE SUB PrintBar (dis!, m$)
DECLARE FUNCTION ScreenCheck! (xa!, ya!)
DECLARE SUB WaterBlock ()
DECLARE SUB Water ()
DECLARE SUB WaterLine ()
DECLARE SUB RaiseLine ()
DECLARE SUB RaiseBlock ()
DECLARE SUB WaterScenD ()
DECLARE SUB WaterScenN ()
DECLARE SUB DelTrack (xb!, yb!)
DECLARE SUB ProgramLoop ()
DECLARE SUB AbandonFile ()
DECLARE SUB DrawTrack (a!, b!, d2!, ov!)
DECLARE SUB AutoTrack ()
DECLARE SUB LaySelTrack ()
DECLARE SUB Quit ()
DECLARE SUB InverScen ()
DECLARE SUB SetFlag ()
DECLARE SUB DecScenNo ()
DECLARE SUB DrawSelTrack ()
DECLARE SUB RaiseScen ()
DECLARE SUB Combine (x4!, y4!, d!)
DECLARE SUB LowerScen ()
DECLARE SUB ReadFile ()
DECLARE SUB ChangeScen (g!)
DECLARE SUB PrintScreen ()
DECLARE SUB PrintBox ()
DECLARE SUB ReadData ()
DECLARE SUB HelpScreen ()
DECLARE SUB SaveToFile ()
DECLARE SUB ChangeScreen (a!, b!, ov!)
DECLARE SUB CurOff ()
DECLARE SUB CurOn ()
DECLARE SUB DrawScen (n!)

COMMON SHARED hicol, trcol, wacol, lycol, height, wid, back, thei
COMMON SHARED twid, hwid, fwid, lwid, hei, bhei, whei, shei, ahei
COMMON SHARED pi, sq, cr, cur1, cur2, nord, wasz, scst, sc, x, y
COMMON SHARED x1, y1, x2, y2, x5, y5, x6, y6, x7, y7, h, w, h3, w3
COMMON SHARED sg1, sg2, xflg, yflg, f, direc$, sav, csr, in$
COMMON SHARED tr(), ly(), inv(), info(), locs(), keys$()
COMMON SHARED help$(), s(), ss(), alt$(), rd(), sz(), auto$()
COMMON SHARED ord(), rec(), wa$(), bck$(), siz$(), nm$()

DIM tr(30, 30), info(18, 18), inv(19), ly(30, 30), rd(5, 16), alt$(1)
DIM sz(255), wa$(2), nm$(12), rec(20, 2), auto$(4), bck$(5), siz$(8)
DIM help$(1256), keys$(80), locs(80, 2), ord(12, 24), s(160), ss(8, 30)

wacol = 1: trcol = 2: lycol = 12: hicol = 7: wasz = 2: scst = 7
thei = 30: twid = 73: hwid = 1: fwid = 28: lwid = 58: whei = 6
shei = 10: bhei = 14: ahei = 18: cur1 = 1: cur2 = 1
sq = 1: pi = 3.14159: cr = 62: nord = 1: enord = 5: sc = 5
h = 1: w = 1: x1 = 1: y1 = 1: x7 = -1: y7 = -1: sav = 0

ReadFile
ReadData
PrintScreen
ProgramLoop

'****************************************************************************
'****************  DATA INFORMATION  ****************************************
'****************************************************************************

DATA "","Alt"

DATA 0,0,1,1,1,2,2,3,3,3,4,5,6,7,7,7
DATA 8,8,9,10,11,12,12,12,13,13,14,14,14,15,15
DATA 0,0,1,1,2,2,3,3,4,4,5,6,7,8,8,9
DATA 10,10,11,12,13,14,14,15,15,16,16,17,17,18,18
DATA 0,1,1,2,2,3,4,4,5,5,6,7,8,9,10,11
DATA 11,12,13,14,15,16,16,17,17,18,19,19,20,20,21
DATA 0,1,2,2,3,4,5,5,6,7,8,9,10,11,11,12
DATA 13,13,14,15,16,17,18,18,19,20,21,22,22,23,24
DATA 0,1,2,3,4,4,5,6,7,8,9,10,11,12,13,14
DATA 14,15,16,17,18,19,20,21,22,23,23,24,25,26,27
DATA 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
DATA 16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 0,1,2,4,5,6,7,8,10,11,12,13,14,15,16,18
DATA 20,21,22,23,24,25,26,28,29,30,31,32,34,35,36
DATA 0,2,3,5,6,8,9,11,12,14,15,16,17,19,20,22
DATA 24,26,28,29,30,31,33,34,36,37,39,40,42,43,45
DATA 0,2,4,6,8,10,12,14,16,18,20,21,22,25,28,30
DATA 32,35,38,39,40,42,44,46,48,50,52,54,56,58,60

DATA "1/2:15 ","3/5:18 ","7/10:21","4/5:24 ","9/10:27","1/1:30 ","6/5:36 ","3/2:45 ","2/1:60 "

DATA 8,10,6,9,7,6,12,13,9,14,11,7,12,11,8,13,14,10
DATA 13,10,10,13,7,18,12,8,8,12,10,17,14,10,10,14,9,17
DATA 11,8,8,11,9,16,13,9,9,13,8,16,12,7,15,12,9,9,14,8,15
DATA 14,7,7,11,7,7,11,10,18,10,9,17,9,8,16,8,7,15,7,10,18
DATA 15,10,6,15,9,6,16,10,6,16,7,6,17,8,6,17,7,6,18,9,6
DATA 18,8,6,11,16,16,11,18,18,12,17,17,12,15,15,13,16,16
DATA 13,18,18,14,15,15,14,17,17,15,13,6,14,16,6,11,17,6
DATA 12,18,6,14,18,18,11,15,15,12,16,16,13,17,17,7,7,7
DATA 8,8,8,9,9,9,10,10,10,11,11,11,12,12,12,13,13,13
DATA 14,14,14,15,15,15,16,16,16,17,17,17,18,18,18

DATA 6,6,6,6,6,6,0,9,10,7,8,17,18,15,16,13,14,11,12,19

DATA 53,54,52,55,50,49,51,48,41,43,47,45,44,46,40,42
DATA 11,12,10,13,5,4,5,4,5,5,5,5,4,4,4,4
DATA 21,22,20,23,15,14,15,14,15,15,15,15,14,14,14,14
DATA 31,32,30,33,25,24,25,24,25,25,25,25,24,24,24,24
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DATA 1,1,1,1,1,1,1,1,1,1,2,2,2,2,1,1
DATA 1,1,1,1,2,2,2,2,1,1,1,1,1,1,2,2
DATA 2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1
DATA 1,1,1,1,2,2,2,2,1,1,1,1,2,2,2,2
DATA 3,4,1,1,1,1,1,1,1,1,1,1,1,1,1,1
DATA 1,1,1,1,1,3,4,2,2,2,2,2,2,2,2,1
DATA 1,1,1,1,1,1,1,1,1,2,2,2,2,1,1,1
DATA 1,1,1,1,1,2,2,2,2,2,2,2,2,1,1,1
DATA 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
DATA 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
DATA 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
DATA 1,1,1,1,1,1

DATA "Banked","Normal","Mud   ","Ice   "

DATA "Small ","Medium","Large "

DATA "Desert  ","Tropical","Alpine  ","City    ","Country "

DATA " Normal Track",23,4,5,74,6,7,8,9,75,76,77,78,79,80,81,82,10,11,12,13,1,179,180,181
DATA "Extra N.Track",12,60,61,62,63,87,88,89,90,91,92,93,94
DATA "    Mud Track",23,14,15,125,16,17,18,19,126,127,128,129,130,131,132,133,20,21,22,23,134,135,136,137
DATA "    Ice Track",23,24,25,138,26,27,28,29,139,140,141,142,143,144,145,146,30,31,32,33,147,148,149,150
DATA " Banked Track",16,48,49,50,51,52,53,54,55,40,41,42,43,44,45,46,47
DATA "  Obsticles 1",10,66,67,70,71,72,73,68,69,83,84
DATA "  Obsticles 2",12,111,112,113,114,109,110,115,116,64,65,85,86
DATA "  High: Ramps",12,56,57,58,59,36,37,38,39,95,96,97,98
DATA "  High: Track",8,34,35,99,100,103,104,101,102
DATA " High: Curves",12,105,106,107,108,117,118,119,120,121,122,123,124
DATA "    Scenery 1",12,151,152,153,154,171,172,173,174,159,160,161,162
DATA "    Scenery 2",16,155,156,157,158,163,164,165,166,167,168,169,170,175,176,177,178

DATA 83,"Moves cursor box up",75,"Moves cursor box left"
DATA 76,"Moves cursor box right",88,"Moves cursor box down"
DATA 1075,"Moves screen window left",1077,"Moves screen window right"
DATA 1072,"Moves screen window up",1080,"Moves screen window down"
DATA 13,"Redraws screen window",65,"Raise ground - CTRL+A,lower ground"
DATA 90,"Decrease ground code by 1",1059,"Set ground code to 06"
DATA 1060,"Set ground code to 10",1061,"Set ground code to 14"
DATA 1062,"Set ground code to 18",49,"Set ground to water 01"
DATA 50,"Set ground to water 02",51,"Set ground to water 03"
DATA 52,"Set ground to water 04",53,"Set ground to water 05"
DATA 68,"Stores coordinates for use with E R C V"
DATA 67,"Inverses all ground between cursor and D"
DATA 69,"Waters all low ground between cursor and D - CTRL+W Destructively waters"
DATA 47,"Deletes single track code",1063,"Increases size of water patch"
DATA 1067,"Selects Banked track for R",1068,"Selects Normal track for R"
DATA 1133,"Selects Mud track for R",1134,"Selects Ice track for R"
DATA 70,"Stores coordinates of corner for use with D , .",44,"Lay selected track from D via F"
DATA 46,"Erase track from D via F",91,"Increase track type by 1"
DATA 73,"Decrease track type by 1",79,"Decrease track piece by 1"
DATA 80,"Increase track piece by 1",59,"Lay selected track piece on cursor position"
DATA 87,"Writes file to disk",81,"Quit The Track Editor (NB SHIFT+Y to confirm)"
DATA 27,"Brings up Help Screen",84,"Opens new track file"
DATA 86,"Raises all ground from D to cursor - CTRL+V Raises line from D"
DATA 32,"Increases selected track type by 1"
DATA 82,"Waters block from D - CTRL+R waters line from D"
DATA 1066,"Increases background type by 1"
DATA 92,"Lays patch of water",1064,"Increases magnification of main window"
DATA 0

DATA 2,7,"Esc",10,7,"F1",14,7,"F2",18,7,"F3",22,7,"F4",28,7,"F5"
DATA 32,7,"F6",40,7,"F8",46,7,"F9",50,7,"F10",54,7,"F11",58,7,"F12"
DATA 7,11,"1",11,11,"2",15,11,"3",19,11,"4",23,11,"5"
DATA 9,13,"Q",13,13,"W",17,13,"E",21,13,"R",25,13,"T",37,13,"I"
DATA 41,13,"O",45,13,"P",49,13,"[",56,13,"Enter"
DATA 10,15,"A",14,15,"S",18,15,"D",22,15,"F",38,15,"K",42,15,"L",46,15,";"
DATA 7,17,"\",11,17,"Z",15,17,"X",19,17,"C",23,17,"V",39,17,",",43,17,".",47,17,"/"
DATA 69,17,"U",69,19,"D",65,19,"L",73,19,"R",26,19,"SPACE BAR"
DATA 0

SUB AbandonFile
   IF sav = 1 THEN
      PrintBar hwid, "File altered; save? (Y)"
      i$ = INKEY$
      WHILE i$ = ""
         i$ = INKEY$
      WEND
      PrintBar hwid, "Press ESC for key help  "
      IF UCASE$(i$) = "Y" THEN
         SaveToFile
         PrintScreen
      END IF
   END IF
END SUB

SUB AutoTrack
   CurOff
   DIM mem(65, 2)
   rc = 0
   sav = 1
   SetFlag
   IF x7 <> -1 THEN
      test = (x7 - x6) * -sg2 / sg1
      IF (y6 - y7) < test THEN
         dir = -1
      ELSE
         dir = 1
      END IF
      IF xflg + yflg > 0 THEN
         dir = 1
      END IF
      IF xflg = 1 AND x7 > x5 THEN
         dir = -1
      END IF
      IF yflg = 1 AND y7 < y5 THEN
         dir = -1
      END IF
      te = sg2 * dir
      wib = te * sg1
      ble = (.5 * sg1) - (.5 * dir) - sg2 + 2
      IF sg1 = -1 THEN
         ble = ble + 1 + (2 * sg2)
      END IF
      IF te = 1 THEN
         conx = x5
         cony = y6
      ELSE
         conx = x6
         cony = y5
      END IF
      IF yflg = 0 THEN
         FOR y8 = y6 TO y5 STEP sg2
            ly(conx, y8) = rd(nord, 7 - wib)
            rc = rc + 1
            mem(rc, 1) = conx
            mem(rc, 2) = y8
         NEXT y8
      END IF
      IF xflg = 0 THEN
         FOR x8 = x6 TO x5 STEP sg1
            ly(x8, cony) = rd(nord, 6 - dir)
            rc = rc + 1
            mem(rc, 1) = x8
            mem(rc, 2) = cony
         NEXT x8
      END IF
      x8 = x6
      y8 = y6
      x9 = x5
      y9 = y5
      IF sg1 = -1 THEN
         SWAP x8, x9
         SWAP y8, y9
      END IF
      IF wib = -1 THEN
         SWAP x8, x9
         SWAP y8, y9
      END IF
      IF xflg <> 1 AND yflg <> 1 THEN
         ly(x8, y8) = rd(nord, 8 + ble)
         rc = rc + 1
         mem(rc, 1) = x8
         mem(rc, 2) = y8
         ly(x9, y9) = rd(nord, 12 + ble)
         rc = rc + 1
         mem(rc, 1) = x9
         mem(rc, 2) = y9
         cx = -.5 * (wib + 1)
         cy = .5 * (dir - 1)
         ly(conx + cx, cony + cy) = rd(nord, ble)
         ly(conx + cx + 1, cony + cy) = 255
         ly(conx + cx + 1, cony + cy + 1) = 253
         ly(conx + cx, cony + cy + 1) = 254
         rc = rc + 1
         mem(rc, 1) = conx + cx
         mem(rc, 2) = cony + cy
      END IF
      FOR a = rc TO 1 STEP -1
         ChangeScreen mem(a, 1), mem(a, 2), -1
      NEXT a
      FOR a = rc TO 1 STEP -1
         DrawTrack mem(a, 1) - w3 + 1, mem(a, 2) - h3 + 1, ly(mem(a, 1), mem(a, 2)), 0
      NEXT a
   END IF
   CurOn
END SUB

SUB C (xa, ya, r, col, st, ed, asp)
   CIRCLE (x + s(xa), y + s(ya)), s(r), col, st, ed, asp
END SUB

SUB ChangeScen (g)
   sav = 1
   tr(x5, y5) = g
   ChangeScreen x5, y5, 0
   CurOn
END SUB

SUB ChangeScreen (a, b, ov)
   x = s(30) * (a - w3 + 1)
   y = s(30) * (b - h3 + 1)
   IF ScreenCheck(0, 0) THEN
      L 0, 0, 30, 30, 0, 2
      L 0, 0, 30, 30, 15, 1
      DrawScen tr(a, b)
      DrawTrack a - w3 + 1, b - h3 + 1, ly(a, b), ov
   END IF
END SUB

SUB Combine (x4, y4, d)
   st = 0
   IF x4 >= 0 AND x4 <= 29 AND y4 >= 0 AND y4 <= 29 THEN
      e = tr(x4, y4)
      IF e > 0 AND e < 6 THEN
         IF d > 0 AND d < 6 THEN
            IF d <> e THEN
               d = 1
            END IF
         END IF
         e = 0
      END IF
      IF d > 0 AND d < 6 THEN
         e = 0
      END IF
      IF e <> 0 THEN
         IF e = 6 OR d = 6 THEN
            d = 6
         ELSE
            d = info(e, d)
            IF d = 19 THEN
               f = f + 1
               rec(f, 1) = x4 - w3 + 2
               rec(f, 2) = y4 - h3 + 2
               st = 1
            END IF
         END IF
      END IF
      IF st = 0 THEN
         tr(x4, y4) = d
         x = s(30) * (x4 - w3 + 1)
         y = s(30) * (y4 - h3 + 1)
         IF ScreenCheck(0, 0) THEN
            ChangeScreen x4, y4, 0
         END IF
      END IF
   END IF
END SUB

SUB CurOff
   LINE (s(30) * (x2 - 1), s(30) * (y2 - 1))-(s(30) * x2, s(30) * y2), , B
END SUB

SUB CurOn
   LINE (s(30) * (x1 - 1), s(30) * (y1 - 1))-(s(30) * x1, s(30) * y1), 0, B
END SUB

SUB DecScenNo
   sav = 1
   tr(x5, y5) = (tr(x5, y5) + 18) MOD 19
   IF tr(x5, y5) = 5 THEN
      tr(x5, y5) = 0
   END IF
   ChangeScreen x5, y5, 0
   CurOn
END SUB

SUB DelTrack (xb, yb)
   xbb = xb
   ybb = yb
   sav = 1
   SELECT CASE ly(xb, yb)
      CASE 255
         xb = xb - 1
      CASE 254
         yb = yb - 1
      CASE 253
         xb = xb - 1
         yb = yb - 1
   END SELECT
   sd = sz(ly(xb, yb))
   ly(xb, yb) = 0
   ChangeScreen xb, yb, 0
   IF sd = 2 THEN
      ly(xb + 1, yb + 1) = 0
      ChangeScreen xb + 1, yb + 1, 0
   END IF
   IF sd MOD 2 = 0 THEN
      ly(xb + 1, yb) = 0
      ChangeScreen xb + 1, yb, 0
   END IF
   IF sd MOD 4 > 1 THEN
      ly(xb, yb + 1) = 0
      ChangeScreen xb, yb + 1, 0
   END IF
   xb = xbb
   yb = ybb
   CurOn
END SUB

SUB DrawScen (n)
   IF ScreenCheck(0, 0) THEN
      SELECT CASE n
         CASE 1
            P 15, 15, wacol, 15
         CASE 2
            L 0, 0, 30, 30, 15, 0
            P 8, 22, wacol, 15
         CASE 3
            L 30, 0, 0, 30, 15, 0
            P 22, 22, wacol, 15
         CASE 4
            L 0, 0, 30, 30, 15, 0
            P 22, 8, wacol, 15
         CASE 5
            L 30, 0, 0, 30, 15, 0
            P 8, 8, wacol, 15
         CASE 6
            P 15, 5, hicol, 15
         CASE 7
            L 0, 15, 30, 15, 15, 0
            P 15, 22, trcol, 15
            P 15, 8, trcol + 8, 15
         CASE 8
            L 15, 0, 15, 30, 15, 0
            P 22, 15, trcol, 15
            P 8, 15, trcol + 8, 15
         CASE 9
            L 0, 15, 30, 15, 15, 0
            P 15, 8, trcol, 15
            P 15, 22, trcol + 8, 15
         CASE 10
            L 15, 0, 15, 30, 15, 0
            P 8, 15, trcol, 15
            P 22, 15, trcol + 8, 15
         CASE 11
            L 30, 0, 0, 30, 15, 0
            L 0, 15, 15, 0, 15, 0
            P 4, 4, trcol + 8, 15
            P 13, 13, trcol, 15
         CASE 12
            L 0, 0, 30, 30, 15, 0
            L 0, 15, 15, 30, 15, 0
            P 4, 26, trcol + 8, 15
            P 12, 18, trcol, 15
         CASE 13
            L 30, 0, 0, 30, 15, 0
            L 15, 30, 30, 15, 15, 0
            P 26, 26, trcol + 8, 15
            P 18, 18, trcol, 15
         CASE 14
            L 0, 0, 30, 30, 15, 0
            L 15, 0, 30, 15, 15, 0
            P 26, 4, trcol + 8, 15
            P 18, 12, trcol, 15
         CASE 15
            L 30, 0, 0, 30, 15, 0
            L 15, 30, 30, 15, 15, 0
            P 26, 26, trcol, 15
            P 18, 18, trcol + 8, 15
            P 8, 8, hicol, 15
         CASE 16
            L 0, 0, 30, 30, 15, 0
            L 15, 0, 30, 15, 15, 0
            P 26, 4, trcol, 15
            P 18, 12, trcol + 8, 15
            P 8, 22, hicol, 15
         CASE 17
            L 30, 0, 0, 30, 15, 0
            L 0, 15, 15, 0, 15, 0
            P 4, 4, trcol, 15
            P 12, 12, trcol + 8, 15
            P 22, 22, hicol, 15
         CASE 18
            L 0, 0, 30, 30, 15, 0
            L 0, 15, 15, 30, 15, 0
            P 4, 26, trcol, 15
            P 12, 18, trcol + 8, 15
            P 22, 8, hicol, 15
      END SELECT
   END IF
END SUB

SUB DrawSelTrack
   scs = sc
   Scale 5
   x = 575
   y = 390
   L 0, 0, 60, 60, 0, 2
   L 0, 0, 60, 60, 15, 1
   L 30, 0, 30, 60, 15, 0
   L 0, 30, 60, 30, 15, 0
   cur2 = ((cur2 + 11) MOD 12) + 1
   IF cur1 < 1 THEN
      cur2 = cur2 - 1
      cur1 = ord(cur2, 0)
   END IF
   IF cur1 > ord(cur2, 0) THEN
      cur1 = 1
      cur2 = cur2 + 1
   END IF
   cur2 = ((cur2 + 11) MOD 12) + 1
   IF cur1 = 0 THEN
      cur1 = 16
   END IF
   c1$ = STR$(cur1)
   c2$ = STR$(ord(cur2, 0))
   PrintBar 62, nm$(cur2) + ":" + RIGHT$(c1$, LEN(c1$) - 1) + "/"
   PRINT RIGHT$(c2$, LEN(c2$) - 1); SPACE$(6 - LEN(c1$) - LEN(c2$));
   DrawTrack x / 30, y / 30, ord(cur2, cur1), 1
   Scale scs
END SUB

SUB DrawTrack (a, b, d2, ov)
   x = s(30) * a
   y = s(30) * b
   arc = ATN(15 / 11)
   cl = lycol
   cl2 = 0
   st = 1
   IF ScreenCheck(-((sz(d2) MOD 4) > 1), -((sz(d2) MOD 2) = 0)) OR ov = 1 THEN
      st = 0
   END IF
   IF ov = -1 THEN
      st = 1
   END IF
   IF st = 0 THEN
      SELECT CASE d2
         CASE 1     'normal, -ud
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            L 5, 6, 25, 10, cl, 2
         CASE 4     'normal, ud
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
         CASE 5     'normal, lr
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
         CASE 6     'normal, dr
            C 30, 30, 20, cl, .5 * pi, pi, sq
            C 30, 30, 19, cl, .5 * pi, pi, sq
            C 30, 30, 18, cl, .5 * pi, pi, sq
            C 30, 30, 10, cl, .5 * pi, pi, sq
            C 30, 30, 11, cl, .5 * pi, pi, sq
            C 30, 30, 12, cl, .5 * pi, pi, sq
         CASE 7     'normal, dl
            C 0, 30, 20, cl, 0, .5 * pi, sq
            C 0, 30, 19, cl, 0, .5 * pi, sq
            C 0, 30, 18, cl, 0, .5 * pi, sq
            C 0, 30, 10, cl, 0, .5 * pi, sq
            C 0, 30, 11, cl, 0, .5 * pi, sq
            C 0, 30, 12, cl, 0, .5 * pi, sq
         CASE 8     'normal, ur
            C 30, 0, 20, cl, pi, 1.5 * pi, sq
            C 30, 0, 19, cl, pi, 1.5 * pi, sq
            C 30, 0, 18, cl, pi, 1.5 * pi, sq
            C 30, 0, 10, cl, pi, 1.5 * pi, sq
            C 30, 0, 11, cl, pi, 1.5 * pi, sq
            C 30, 0, 12, cl, pi, 1.5 * pi, sq
         CASE 9     'normal, ul
            C 0, 0, 20, cl, 1.5 * pi, 0, sq
            C 0, 0, 19, cl, 1.5 * pi, 0, sq
            C 0, 0, 18, cl, 1.5 * pi, 0, sq
            C 0, 0, 10, cl, 1.5 * pi, 0, sq
            C 0, 0, 11, cl, 1.5 * pi, 0, sq
            C 0, 0, 12, cl, 1.5 * pi, 0, sq
         CASE 10    'normal, dr, 2*2
            C 60, 60, 50, cl, .5 * pi, pi, sq
            C 60, 60, 49, cl, .5 * pi, pi, sq
            C 60, 60, 48, cl, .5 * pi, pi, sq
            C 60, 60, 40, cl, .5 * pi, pi, sq
            C 60, 60, 41, cl, .5 * pi, pi, sq
            C 60, 60, 42, cl, .5 * pi, pi, sq
         CASE 11    'normal, dl, 2*2
            C 0, 60, 50, cl, 0, .5 * pi, sq
            C 0, 60, 49, cl, 0, .5 * pi, sq
            C 0, 60, 48, cl, 0, .5 * pi, sq
            C 0, 60, 40, cl, 0, .5 * pi, sq
            C 0, 60, 41, cl, 0, .5 * pi, sq
            C 0, 60, 42, cl, 0, .5 * pi, sq
         CASE 12    'normal, ur, 2*2
            C 60, 0, 50, cl, pi, 1.5 * pi, sq
            C 60, 0, 49, cl, pi, 1.5 * pi, sq
            C 60, 0, 48, cl, pi, 1.5 * pi, sq
            C 60, 0, 40, cl, pi, 1.5 * pi, sq
            C 60, 0, 41, cl, pi, 1.5 * pi, sq
            C 60, 0, 42, cl, pi, 1.5 * pi, sq
         CASE 13    'normal, ul, 2*2
            C 0, 0, 50, cl, 1.5 * pi, 0, sq
            C 0, 0, 49, cl, 1.5 * pi, 0, sq
            C 0, 0, 48, cl, 1.5 * pi, 0, sq
            C 0, 0, 40, cl, 1.5 * pi, 0, sq
            C 0, 0, 41, cl, 1.5 * pi, 0, sq
            C 0, 0, 42, cl, 1.5 * pi, 0, sq
         CASE 14    'mud, ud
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
         CASE 15    'mud, lr
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
         CASE 16    'mud, dr
            C 30, 30, 20, cl, .5 * pi, pi, sq
            C 30, 30, 19, cl, .5 * pi, pi, sq
            C 30, 30, 10, cl, .5 * pi, pi, sq
            C 30, 30, 11, cl, .5 * pi, pi, sq
         CASE 17    'mud, dl
            C 0, 30, 20, cl, 0, .5 * pi, sq
            C 0, 30, 19, cl, 0, .5 * pi, sq
            C 0, 30, 10, cl, 0, .5 * pi, sq
            C 0, 30, 11, cl, 0, .5 * pi, sq
         CASE 18    'mud, ur
            C 30, 0, 20, cl, pi, 1.5 * pi, sq
            C 30, 0, 19, cl, pi, 1.5 * pi, sq
            C 30, 0, 10, cl, pi, 1.5 * pi, sq
            C 30, 0, 11, cl, pi, 1.5 * pi, sq
         CASE 19    'mud, ul
            C 0, 0, 20, cl, 1.5 * pi, 0, sq
            C 0, 0, 19, cl, 1.5 * pi, 0, sq
            C 0, 0, 10, cl, 1.5 * pi, 0, sq
            C 0, 0, 11, cl, 1.5 * pi, 0, sq
         CASE 20    'mud, dr, 2*2
            C 60, 60, 50, cl, .5 * pi, pi, sq
            C 60, 60, 49, cl, .5 * pi, pi, sq
            C 60, 60, 40, cl, .5 * pi, pi, sq
            C 60, 60, 41, cl, .5 * pi, pi, sq
         CASE 21    'mud, dl, 2*2
            C 0, 60, 50, cl, 0, .5 * pi, sq
            C 0, 60, 49, cl, 0, .5 * pi, sq
            C 0, 60, 40, cl, 0, .5 * pi, sq
            C 0, 60, 41, cl, 0, .5 * pi, sq
         CASE 22    'mud, ur, 2*2
            C 60, 0, 50, cl, pi, 1.5 * pi, sq
            C 60, 0, 49, cl, pi, 1.5 * pi, sq
            C 60, 0, 40, cl, pi, 1.5 * pi, sq
            C 60, 0, 41, cl, pi, 1.5 * pi, sq
         CASE 23    'mud, ul, 2*2
            C 0, 0, 50, cl, 1.5 * pi, 0, sq
            C 0, 0, 49, cl, 1.5 * pi, 0, sq
            C 0, 0, 40, cl, 1.5 * pi, 0, sq
            C 0, 0, 41, cl, 1.5 * pi, 0, sq
         CASE 24    'ice, ud
            L 10, 0, 20, 30, cl, 1
         CASE 25    'ice, lr
            L 0, 10, 30, 20, cl, 1
         CASE 26    'ice, dr
            C 30, 30, 20, cl, .5 * pi, pi, sq
            C 30, 30, 10, cl, .5 * pi, pi, sq
         CASE 27    'ice, dl
            C 0, 30, 20, cl, 0, .5 * pi, sq
            C 0, 30, 10, cl, 0, .5 * pi, sq
         CASE 28    'ice, ul
            C 30, 0, 20, cl, pi, 1.5 * pi, sq
            C 30, 0, 10, cl, pi, 1.5 * pi, sq
         CASE 29    'ice, ur
            C 0, 0, 20, cl, 1.5 * pi, 0, sq
            C 0, 0, 10, cl, 1.5 * pi, 0, sq
         CASE 30    'ice, dr, 2*2
            C 60, 60, 50, cl, .5 * pi, pi, sq
            C 60, 60, 40, cl, .5 * pi, pi, sq
         CASE 31    'ice, dl, 2*2
            C 0, 60, 50, cl, 0, .5 * pi, sq
            C 0, 60, 40, cl, 0, .5 * pi, sq
         CASE 32    'ice, ur, 2*2
            C 60, 0, 50, cl, pi, 1.5 * pi, sq
            C 60, 0, 40, cl, pi, 1.5 * pi, sq
         CASE 33    'ice, ul, 2*2
            C 0, 0, 50, cl, 1.5 * pi, 0, sq
            C 0, 0, 40, cl, 1.5 * pi, 0, sq
         CASE 34    'high, ud
            L 1, 0, 10, 30, cl, 2
            L 2, 2, 9, 28, cl2, 2
            L 10, 3, 20, 7, cl, 1
            L 10, 13, 20, 17, cl, 1
            L 10, 23, 20, 27, cl, 1
            P 15, 5, cl, cl
            P 15, 15, cl, cl
            P 15, 25, cl, cl
         CASE 35    'high, lr
            L 0, 1, 30, 10, cl, 2
            L 2, 2, 28, 9, cl2, 2
            L 3, 10, 7, 20, cl, 1
            L 13, 10, 17, 20, cl, 1
            L 23, 10, 27, 20, cl, 1
            P 5, 15, cl, cl
            P 15, 15, cl, cl
            P 25, 15, cl, cl
         CASE 36    'ramp, lR
            L 0, 11, 30, 2, cl, 0
            L 0, 10, 30, 1, cl, 0
            L 0, 20, 30, 10, cl, 0
            L 0, 20, 15, 20, cl, 0
            L 15, 15, 15, 20, cl, 0
         CASE 37    'ramp, Lr
            L 30, 11, 0, 2, cl, 0
            L 30, 10, 0, 1, cl, 0
            L 30, 19, 0, 10, cl, 0
            L 15, 20, 30, 20, cl, 0
            L 15, 15, 15, 20, cl, 0
         CASE 38    'ramp, Ud
            L 11, 30, 2, 0, cl, 0
            L 10, 30, 1, 0, cl, 0
            L 19, 30, 10, 0, cl, 0
            L 20, 15, 20, 30, cl, 0
            L 15, 15, 20, 15, cl, 0
         CASE 39    'ramp, uD
            L 11, 0, 2, 30, cl, 0
            L 10, 0, 1, 30, cl, 0
            L 19, 0, 10, 30, cl, 0
            L 20, 0, 20, 15, cl, 0
            L 15, 15, 20, 15, cl, 0
         CASE 40    'bank, Ud-L
            L 10, 0, 10, 30, cl, 0
            L 11, 0, 11, 30, cl, 0
            L 12, 0, 12, 30, cl, 0
            L 10, 15, 19, 30, cl, 0
            L 20, 0, 20, 30, cl, 0
         CASE 41    'bank, lR-U
            L 0, 10, 30, 10, cl, 0
            L 0, 11, 30, 11, cl, 0
            L 0, 12, 30, 12, cl, 0
            L 0, 19, 15, 10, cl, 0
            L 0, 20, 30, 20, cl, 0
         CASE 42    'bank, uD-R
            L 20, 0, 20, 30, cl, 0
            L 19, 0, 19, 30, cl, 0
            L 18, 0, 18, 30, cl, 0
            L 11, 0, 20, 15, cl, 0
            L 10, 0, 10, 30, cl, 0
         CASE 43    'bank, Lr-D
            L 0, 20, 30, 20, cl, 0
            L 0, 19, 30, 19, cl, 0
            L 0, 18, 30, 18, cl, 0
            L 15, 20, 30, 11, cl, 0
            L 0, 10, 30, 10, cl, 0
         CASE 44    'bank, Ud-R
            L 20, 0, 20, 30, cl, 0
            L 19, 0, 19, 30, cl, 0
            L 18, 0, 18, 30, cl, 0
            L 11, 30, 20, 15, cl, 0
            L 10, 0, 10, 30, cl, 0
         CASE 45    'bank, lR-D
            L 0, 20, 30, 20, cl, 0
            L 0, 19, 30, 19, cl, 0
            L 0, 18, 30, 18, cl, 0
            L 0, 11, 15, 20, cl, 0
            L 0, 10, 30, 10, cl, 0
         CASE 46    'bank, uD-L
            L 10, 0, 10, 30, cl, 0
            L 11, 0, 11, 30, cl, 0
            L 12, 0, 12, 30, cl, 0
            L 10, 15, 19, 0, cl, 0
            L 20, 0, 20, 30, cl, 0
         CASE 47    'bank, Lr-U
            L 0, 10, 30, 10, cl, 0
            L 0, 11, 30, 11, cl, 0
            L 0, 12, 30, 12, cl, 0
            L 15, 10, 30, 19, cl, 0
            L 0, 20, 30, 20, cl, 0
         CASE 48    'bank, UD-L
            L 10, 0, 10, 30, cl, 0
            L 11, 0, 11, 30, cl, 0
            L 12, 0, 12, 30, cl, 0
            L 20, 0, 20, 30, cl, 0
         CASE 49    'bank, UD-R
            L 20, 0, 20, 30, cl, 0
            L 19, 0, 19, 30, cl, 0
            L 18, 0, 18, 30, cl, 0
            L 10, 0, 10, 30, cl, 0
         CASE 50    'bank, LR-U
            L 0, 10, 30, 10, cl, 0
            L 0, 11, 30, 11, cl, 0
            L 0, 12, 30, 12, cl, 0
            L 0, 20, 30, 20, cl, 0
         CASE 51    'bank, LR-D
            L 0, 20, 30, 20, cl, 0
            L 0, 19, 30, 19, cl, 0
            L 0, 18, 30, 18, cl, 0
            L 0, 10, 30, 10, cl, 0
         CASE 52    'bank, DR, 2*2
            C 60, 60, 50, cl, .5 * pi, pi, sq
            C 60, 60, 49, cl, .5 * pi, pi, sq
            C 60, 60, 48, cl, .5 * pi, pi, sq
            C 60, 60, 40, cl, .5 * pi, pi, sq
         CASE 53    'bank, DL, 2*2
            C 0, 60, 50, cl, 0, .5 * pi, sq
            C 0, 60, 49, cl, 0, .5 * pi, sq
            C 0, 60, 48, cl, 0, .5 * pi, sq
            C 0, 60, 40, cl, 0, .5 * pi, sq
         CASE 54    'bank, UR, 2*2
            C 60, 0, 50, cl, pi, 1.5 * pi, sq
            C 60, 0, 49, cl, pi, 1.5 * pi, sq
            C 60, 0, 48, cl, pi, 1.5 * pi, sq
            C 60, 0, 40, cl, pi, 1.5 * pi, sq
         CASE 55    'bank, UL, 2*2
            C 0, 0, 50, cl, 1.5 * pi, 0, sq
            C 0, 0, 49, cl, 1.5 * pi, 0, sq
            C 0, 0, 48, cl, 1.5 * pi, 0, sq
            C 0, 0, 40, cl, 1.5 * pi, 0, sq
         CASE 56    'jump, lR
            L 0, 10, 25, 0, cl, 0
            L 25, 0, 30, 10, cl, 0
            L 0, 20, 25, 10, cl, 0
            L 25, 10, 30, 20, cl, 0
            L 0, 20, 30, 20, cl, 0
            L 25, 0, 25, 10, cl, 0
            P 20, 15, 15, cl
         CASE 57    'jump, Lr
            L 30, 10, 5, 0, cl, 0
            L 5, 0, 0, 10, cl, 0
            L 30, 20, 5, 10, cl, 0
            L 5, 10, 0, 20, cl, 0
            L 30, 20, 0, 20, cl, 0
            L 5, 0, 5, 10, cl, 0
            P 10, 15, 15, cl
         CASE 58    'jump, Ud
            L 10, 30, 0, 5, cl, 0
            L 0, 5, 10, 0, cl, 0
            L 20, 30, 10, 5, cl, 0
            L 10, 5, 20, 0, cl, 0
            L 20, 30, 20, 0, cl, 0
            L 0, 5, 10, 5, cl, 0
            P 15, 10, 15, cl
         CASE 59    'jump, uD
            L 10, 0, 0, 25, cl, 0
            L 0, 25, 10, 30, cl, 0
            L 20, 0, 10, 25, cl, 0
            L 10, 25, 20, 30, cl, 0
            L 20, 0, 20, 30, cl, 0
            L 0, 25, 10, 25, cl, 0
            P 15, 20, 15, cl
         CASE 60    'normal, u(r)d(l), 2*2
            FOR r = 0 TO 2
               C 52, 60, r + 32, cl, pi - arc, pi, 1
               C 8, 0, r + 32, cl, (2 * pi) - arc, 0, 1
            NEXT r
            FOR r = 8 TO 10
               C 52, 60, r + 32, cl, pi - arc, pi, 1
               C 8, 0, r + 32, cl, (2 * pi) - arc, 0, 1
            NEXT r
         CASE 61    'normal, l(d)r(u), 2*2
            FOR r = 0 TO 2
               C 0, 8, r + 32, cl, 1.5 * pi, (1.5 * pi) + arc, 1
               C 60, 52, r + 32, cl, pi / 2, (pi / 2) + arc, 1
            NEXT r
            FOR r = 8 TO 10
               C 0, 8, r + 32, cl, 1.5 * pi, (1.5 * pi) + arc, 1
               C 60, 52, r + 32, cl, pi / 2, (pi / 2) + arc, 1
            NEXT r
         CASE 62    'normal, u(l)d(r), 2*2
            FOR r = 0 TO 2
               C 8, 60, r + 32, cl, 0, arc, 1
               C 52, 0, r + 32, cl, pi, pi + arc, 1
            NEXT r
            FOR r = 8 TO 10
               C 8, 60, r + 32, cl, 0, arc, 1
               C 52, 0, r + 32, cl, pi, pi + arc, 1
            NEXT r
         CASE 63    'normal, l(u)r(d), 2*2
            FOR r = 0 TO 2
               C 0, 52, r + 32, cl, (pi / 2) - arc, pi / 2, 1
               C 60, 8, r + 32, cl, (1.5 * pi) - arc, 1.5 * pi, 1
            NEXT r
            FOR r = 8 TO 10
               C 0, 52, r + 32, cl, (pi / 2) - arc, pi / 2, 1
               C 60, 8, r + 32, cl, (1.5 * pi) - arc, 1.5 * pi, 1
            NEXT r
         CASE 64    'loop, ud, 1*2
            L 10, 0, 5, 45, cl, 0
            L 20, 60, 25, 15, cl, 0
            L 15, 15, 5, 45, cl, 0
            L 25, 15, 15, 45, cl, 0
            L 20, 0, 18, 15, cl, 0
            L 10, 60, 12, 45, cl, 0
            FOR ac = 0 TO pi STEP (pi / 8)
               sy = 15 * COS(ac)
               sx = sy / 3
               L 20 - sx, 30 + sy, 10 - sx, 30 + sy, cl, 0
            NEXT ac
         CASE 65    'loop, lr, 2*1
            L 0, 10, 45, 5, cl, 0
            L 60, 20, 15, 25, cl, 0
            L 15, 15, 45, 5, cl, 0
            L 15, 25, 45, 15, cl, 0
            L 0, 20, 15, 18, cl, 0
            L 60, 10, 45, 12, cl, 0
            FOR ac = 0 TO pi STEP (pi / 8)
               sx = 15 * COS(ac)
               sy = sx / 3
               L 30 + sx, 20 - sy, 30 + sx, 10 - sy, cl, 0
            NEXT ac
         CASE 66    'tunnel, UD
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            L 6, 5, 24, 25, cl, 2
            L 8, 7, 22, 23, cl2, 2
         CASE 67    'tunnel, LR
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
            L 5, 6, 25, 24, cl, 2
            L 7, 8, 23, 22, cl2, 2
         CASE 68    'tube, UD
            L 10, 0, 20, 30, cl, 1
            FOR an = 10 TO 30 STEP 10
               C 15, an, 8, cl, 0, pi, 1.15
            NEXT an
         CASE 69    'tube, LR
            L 0, 10, 30, 20, cl, 1
            FOR an = 0 TO 20 STEP 10
               C an, 15, 8, cl, 1.5 * pi, .5 * pi, .8
            NEXT an
         CASE 70    'tube, Ud
            L 12, 0, 18, 30, cl, 1
            L 10, 0, 11, 30, cl, 0
            L 7, 0, 10, 30, cl, 0
            L 20, 0, 19, 30, cl, 0
            L 23, 0, 20, 30, cl, 0
         CASE 71    'tube, uD
            L 12, 30, 18, 0, cl, 1
            L 10, 30, 11, 0, cl, 0
            L 7, 30, 10, 0, cl, 0
            L 20, 30, 19, 0, cl, 0
            L 23, 30, 20, 0, cl, 0
         CASE 72    'tube, Lr
            L 0, 12, 30, 18, cl, 1
            L 0, 10, 30, 11, cl, 0
            L 0, 7, 30, 10, cl, 0
            L 0, 20, 30, 19, cl, 0
            L 0, 23, 30, 20, cl, 0
         CASE 73    'tube, lR
            L 0, 12, 30, 18, cl, 1
            L 0, 11, 30, 10, cl, 0
            L 0, 10, 30, 7, cl, 0
            L 0, 19, 30, 20, cl, 0
            L 0, 20, 30, 23, cl, 0
         CASE 74    'normal, ud/lr
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
         CASE 75    'normal, ud/dl
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            C 0, 30, 20, cl, 0, .5 * pi, sq
            C 0, 30, 19, cl, 0, .5 * pi, sq
            C 0, 30, 18, cl, 0, .5 * pi, sq
            C 0, 30, 10, cl, 0, .5 * pi, sq
            C 0, 30, 11, cl, 0, .5 * pi, sq
            C 0, 30, 12, cl, 0, .5 * pi, sq
         CASE 76    'normal, lr/dr
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
            C 30, 30, 20, cl, .5 * pi, pi, sq
            C 30, 30, 19, cl, .5 * pi, pi, sq
            C 30, 30, 18, cl, .5 * pi, pi, sq
            C 30, 30, 10, cl, .5 * pi, pi, sq
            C 30, 30, 11, cl, .5 * pi, pi, sq
            C 30, 30, 12, cl, .5 * pi, pi, sq
         CASE 77    'normal, ud/ur
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            C 30, 0, 20, cl, pi, 1.5 * pi, sq
            C 30, 0, 19, cl, pi, 1.5 * pi, sq
            C 30, 0, 18, cl, pi, 1.5 * pi, sq
            C 30, 0, 10, cl, pi, 1.5 * pi, sq
            C 30, 0, 11, cl, pi, 1.5 * pi, sq
            C 30, 0, 12, cl, pi, 1.5 * pi, sq
         CASE 78    'normal, lr/ul
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
            C 0, 0, 20, cl, 1.5 * pi, 0, sq
            C 0, 0, 19, cl, 1.5 * pi, 0, sq
            C 0, 0, 18, cl, 1.5 * pi, 0, sq
            C 0, 0, 10, cl, 1.5 * pi, 0, sq
            C 0, 0, 11, cl, 1.5 * pi, 0, sq
            C 0, 0, 12, cl, 1.5 * pi, 0, sq
         CASE 79    'normal, ud/dr
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            C 30, 30, 20, cl, .5 * pi, pi, sq
            C 30, 30, 19, cl, .5 * pi, pi, sq
            C 30, 30, 18, cl, .5 * pi, pi, sq
            C 30, 30, 10, cl, .5 * pi, pi, sq
            C 30, 30, 11, cl, .5 * pi, pi, sq
            C 30, 30, 12, cl, .5 * pi, pi, sq
         CASE 80    'normal, lr/ur
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
            C 30, 0, 20, cl, pi, 1.5 * pi, sq
            C 30, 0, 19, cl, pi, 1.5 * pi, sq
            C 30, 0, 18, cl, pi, 1.5 * pi, sq
            C 30, 0, 10, cl, pi, 1.5 * pi, sq
            C 30, 0, 11, cl, pi, 1.5 * pi, sq
            C 30, 0, 12, cl, pi, 1.5 * pi, sq
         CASE 81    'normal, ud/ul
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            C 0, 0, 20, cl, 1.5 * pi, 0, sq
            C 0, 0, 19, cl, 1.5 * pi, 0, sq
            C 0, 0, 18, cl, 1.5 * pi, 0, sq
            C 0, 0, 10, cl, 1.5 * pi, 0, sq
            C 0, 0, 11, cl, 1.5 * pi, 0, sq
            C 0, 0, 12, cl, 1.5 * pi, 0, sq
         CASE 82    'normal, lr/dl
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
            C 0, 30, 20, cl, 0, .5 * pi, sq
            C 0, 30, 19, cl, 0, .5 * pi, sq
            C 0, 30, 18, cl, 0, .5 * pi, sq
            C 0, 30, 10, cl, 0, .5 * pi, sq
            C 0, 30, 11, cl, 0, .5 * pi, sq
            C 0, 30, 12, cl, 0, .5 * pi, sq
         CASE 83    'tube, u|d
            L 10, 0, 20, 30, cl, 1
            L 8, 13, 22, 17, cl, 2
            FOR an = 10 TO 30 STEP 20
               C 15, an, 8, cl, 0, pi, 1.15
            NEXT an
         CASE 84    'tube, l|r
            L 0, 10, 30, 20, cl, 1
            L 13, 8, 17, 22, cl, 2
            FOR an = 0 TO 20 STEP 20
               C an, 15, 8, cl, 1.5 * pi, .5 * pi, .8
            NEXT an
         CASE 85    'corkscrew, ud, 1*2
            L 10, 0, 15, 20, cl, 0
            L 20, 60, 15, 40, cl, 0
            L 20, 0, 25, 10, cl, 0
            L 10, 60, 5, 50, cl, 0
            L 25, 10, 5, 30, cl, 0
            L 5, 50, 25, 30, cl, 0
            FOR ac = 0 TO pi STEP (pi / 8)
               sy = 10 * COS(ac)
               sx = sy
               L 15 - sx, 20 + sy, 15 - sx, 40 + sy, cl, 0
            NEXT ac
         CASE 86    'corkscrew, lr, 2*1
            L 0, 10, 20, 15, cl, 0
            L 60, 20, 40, 15, cl, 0
            L 0, 20, 10, 25, cl, 0
            L 60, 10, 50, 5, cl, 0
            L 10, 25, 30, 5, cl, 0
            L 50, 5, 30, 25, cl, 0
            FOR ac = 0 TO pi STEP (pi / 8)
               sy = 10 * COS(ac)
               sx = sy
               L 20 + sx, 15 - sy, 40 + sx, 15 - sy, cl, 0
            NEXT ac
         CASE 87    'normal, ud/dl, 2*2
            C 0, 60, 50, cl, 0, .5 * pi, sq
            C 0, 60, 49, cl, 0, .5 * pi, sq
            C 0, 60, 48, cl, 0, .5 * pi, sq
            C 0, 60, 40, cl, 0, .5 * pi, sq
            C 0, 60, 41, cl, 0, .5 * pi, sq
            C 0, 60, 42, cl, 0, .5 * pi, sq
            L 40, 0, 50, 60, cl, 1
            L 41, 0, 49, 60, cl, 1
            L 42, 0, 48, 60, cl, 1
         CASE 88    'normal, lr/dr, 2*2
            C 60, 60, 50, cl, .5 * pi, pi, sq
            C 60, 60, 49, cl, .5 * pi, pi, sq
            C 60, 60, 48, cl, .5 * pi, pi, sq
            C 60, 60, 40, cl, .5 * pi, pi, sq
            C 60, 60, 41, cl, .5 * pi, pi, sq
            C 60, 60, 42, cl, .5 * pi, pi, sq
            L 0, 10, 60, 20, cl, 1
            L 0, 11, 60, 19, cl, 1
            L 0, 12, 60, 18, cl, 1
         CASE 89    'normal, ud/ur, 2*2
            C 60, 0, 50, cl, pi, 1.5 * pi, sq
            C 60, 0, 49, cl, pi, 1.5 * pi, sq
            C 60, 0, 48, cl, pi, 1.5 * pi, sq
            C 60, 0, 40, cl, pi, 1.5 * pi, sq
            C 60, 0, 41, cl, pi, 1.5 * pi, sq
            C 60, 0, 42, cl, pi, 1.5 * pi, sq
            L 10, 0, 20, 60, cl, 1
            L 11, 0, 19, 60, cl, 1
            L 12, 0, 18, 60, cl, 1
         CASE 90    'normal, lr/ul, 2*2
            C 0, 0, 50, cl, 1.5 * pi, 0, sq
            C 0, 0, 49, cl, 1.5 * pi, 0, sq
            C 0, 0, 48, cl, 1.5 * pi, 0, sq
            C 0, 0, 40, cl, 1.5 * pi, 0, sq
            C 0, 0, 41, cl, 1.5 * pi, 0, sq
            C 0, 0, 42, cl, 1.5 * pi, 0, sq
            L 0, 40, 60, 50, cl, 1
            L 0, 41, 60, 49, cl, 1
            L 0, 42, 60, 48, cl, 1
         CASE 91    'normal, ud/dr, 2*2
            C 60, 60, 50, cl, .5 * pi, pi, sq
            C 60, 60, 49, cl, .5 * pi, pi, sq
            C 60, 60, 48, cl, .5 * pi, pi, sq
            C 60, 60, 40, cl, .5 * pi, pi, sq
            C 60, 60, 41, cl, .5 * pi, pi, sq
            C 60, 60, 42, cl, .5 * pi, pi, sq
            L 10, 0, 20, 60, cl, 1
            L 11, 0, 19, 60, cl, 1
            L 12, 0, 18, 60, cl, 1
         CASE 92    'normal, lr,ur, 2*2
            C 60, 0, 50, cl, pi, 1.5 * pi, sq
            C 60, 0, 49, cl, pi, 1.5 * pi, sq
            C 60, 0, 48, cl, pi, 1.5 * pi, sq
            C 60, 0, 40, cl, pi, 1.5 * pi, sq
            C 60, 0, 41, cl, pi, 1.5 * pi, sq
            C 60, 0, 42, cl, pi, 1.5 * pi, sq
            L 0, 40, 60, 50, cl, 1
            L 0, 41, 60, 49, cl, 1
            L 0, 42, 60, 48, cl, 1
         CASE 93    'normal, ud/ul, 2*2
            C 0, 0, 50, cl, 1.5 * pi, 0, sq
            C 0, 0, 49, cl, 1.5 * pi, 0, sq
            C 0, 0, 48, cl, 1.5 * pi, 0, sq
            C 0, 0, 40, cl, 1.5 * pi, 0, sq
            C 0, 0, 41, cl, 1.5 * pi, 0, sq
            C 0, 0, 42, cl, 1.5 * pi, 0, sq
            L 40, 0, 50, 60, cl, 1
            L 41, 0, 49, 60, cl, 1
            L 42, 0, 48, 60, cl, 1
         CASE 94    'normal, lr/dl, 2*2
            C 0, 60, 50, cl, 0, .5 * pi, sq
            C 0, 60, 49, cl, 0, .5 * pi, sq
            C 0, 60, 48, cl, 0, .5 * pi, sq
            C 0, 60, 40, cl, 0, .5 * pi, sq
            C 0, 60, 41, cl, 0, .5 * pi, sq
            C 0, 60, 42, cl, 0, .5 * pi, sq
            L 0, 10, 60, 20, cl, 1
            L 0, 11, 60, 19, cl, 1
            L 0, 12, 60, 18, cl, 1
         CASE 95    'high, lR
            L 0, 11, 30, 2, cl, 0
            L 0, 10, 30, 1, cl, 0
            L 0, 20, 30, 10, cl, 0
            L 0, 20, 30, 20, cl, 0
            L 30, 1, 30, 20, cl, 0
            P 18, 18, 15, cl
         CASE 96    'high, Lr
            L 30, 11, 0, 2, cl, 0
            L 30, 10, 0, 1, cl, 0
            L 30, 19, 0, 10, cl, 0
            L 30, 20, 0, 20, cl, 0
            L 0, 1, 0, 20, cl, 0
            P 12, 18, 15, cl
         CASE 97    'high, Ud
            L 11, 30, 2, 0, cl, 0
            L 10, 30, 1, 0, cl, 0
            L 19, 30, 10, 0, cl, 0
            L 20, 30, 20, 0, cl, 0
            L 1, 0, 20, 0, cl, 0
            P 18, 18, 15, cl
         CASE 98    'high, uD
            L 11, 0, 2, 30, cl, 0
            L 10, 0, 1, 30, cl, 0
            L 19, 0, 10, 30, cl, 0
            L 20, 0, 20, 30, cl, 0
            L 1, 30, 20, 30, cl, 0
            P 18, 18, 15, cl
         CASE 99    'high, UD
            L 1, 0, 10, 30, cl, 2
            L 1, 30, 20, 30, cl, 0
            L 2, 2, 9, 28, cl2, 2
            L 1, 0, 20, 0, cl, 0
            L 20, 0, 20, 30, cl, 0
            P 15, 15, 15, cl
         CASE 100   'high, LR
            L 0, 1, 30, 10, cl, 2
            L 30, 1, 30, 20, cl, 0
            L 2, 2, 28, 9, cl2, 2
            L 0, 1, 0, 20, cl, 0
            L 0, 20, 30, 20, cl, 0
            P 15, 15, 15, cl
         CASE 101   'high, ud/LR
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
            L 1, 0, 10, 30, cl, 2
            L 2, 2, 9, 28, cl2, 2
            L 1, 0, 20, 0, cl, 0
            L 1, 30, 20, 30, cl, 0
            L 10, 7, 20, 0, cl, 0
            L 10, 23, 20, 30, cl, 0
            P 12, 2, 15, cl
            P 12, 28, 15, cl
         CASE 102   'high, UD/lr
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            L 0, 1, 30, 10, cl, 2
            L 2, 2, 28, 9, cl2, 2
            L 0, 1, 0, 20, cl, 0
            L 30, 1, 30, 20, cl, 0
            L 7, 10, 0, 20, cl, 0
            L 23, 10, 30, 20, cl, 0
            P 2, 12, 15, cl
            P 28, 12, 15, cl
         CASE 103   'high, UD/~lr
            L 1, 0, 10, 30, cl, 2
            L 2, 2, 9, 28, cl2, 2
            L 1, 0, 20, 0, cl, 0
            L 1, 30, 20, 30, cl, 0
            L 10, 7, 20, 0, cl, 0
            L 10, 23, 20, 30, cl, 0
            P 12, 2, 15, cl
            P 12, 28, 15, cl
         CASE 104   'high, ~ud/LR
            L 0, 1, 30, 10, cl, 2
            L 2, 2, 28, 9, cl2, 2
            L 0, 1, 0, 20, cl, 0
            L 30, 1, 30, 20, cl, 0
            L 7, 10, 0, 20, cl, 0
            L 23, 10, 30, 20, cl, 0
            P 2, 12, 15, cl
            P 28, 12, 15, cl
         CASE 105   'high, DR, 2*2
            C 60, 60, 60, cl, .5 * pi, pi, sq
            C 60, 60, 59, cl, .5 * pi, pi, sq
            C 60, 60, 50, cl, .5 * pi, pi, sq
            FOR aca = (17 * pi / 16) TO (23 * pi / 16) STEP (pi / 8)
               FOR acb = aca - (pi / 64) TO aca + (pi / 64) STEP (pi / 192)
                  L 60 + (50 * COS(acb)), 60 + (50 * SIN(acb)), 60 + (40 * COS(acb)), 60 + (40 * SIN(acb)), cl, 0
               NEXT acb
            NEXT aca
         CASE 106   'high, DL, 2*2
            sq = 19 / 12
            C 0, 60, 60, cl, 0, .5 * pi, sq
            C 0, 60, 59, cl, 0, .5 * pi, sq
            C 0, 60, 50, cl, 0, .5 * pi, sq
            FOR aca = (25 * pi / 16) TO (31 * pi / 16) STEP (pi / 8)
               FOR acb = aca - (pi / 64) TO aca + (pi / 64) STEP (pi / 192)
                  L (50 * COS(acb) * 12 / 19), 60 + (50 * SIN(acb)), (40 * COS(acb) * 12 / 19), 60 + (40 * SIN(acb)), cl, 0
               NEXT acb
            NEXT aca
            sq = 1
         CASE 107   'high, UR, 2*2
            sq = 19 / 30
            C 60, 0, 60, cl, pi, 1.5 * pi, sq
            C 60, 0, 59, cl, pi, 1.5 * pi, sq
            C 60, 0, 50, cl, pi, 1.5 * pi, sq
            FOR aca = (9 * pi / 16) TO (15 * pi / 16) STEP (pi / 8)
               FOR acb = aca - (pi / 64) TO aca + (pi / 64) STEP (pi / 192)
                  L 60 + (50 * COS(acb)), (50 * SIN(acb) * 19 / 30), 60 + (40 * COS(acb)), (40 * SIN(acb) * 19 / 30), cl, 0
               NEXT acb
            NEXT aca
            sq = 1
         CASE 108   'high, UL, 2*2
            C 0, 0, 40, cl, 1.5 * pi, 0, sq
            C 0, 0, 39, cl, 1.5 * pi, 0, sq
            C 0, 0, 30, cl, 1.5 * pi, 0, sq
            FOR aca = (pi / 16) TO (7 * pi / 16) STEP (pi / 8)
               FOR acb = aca - (pi / 64) TO aca + (pi / 64) STEP (pi / 192)
                  L (30 * COS(acb)), (30 * SIN(acb)), (20 * COS(acb)), (20 * SIN(acb)), cl, 0
               NEXT acb
            NEXT aca
         CASE 109   'normal, u(l)d(l)/u(r)d(r)
            L 2, 0, 12, 30, cl, 1
            L 3, 0, 11, 30, cl, 1
            L 4, 0, 10, 30, cl, 1
            L 18, 0, 28, 30, cl, 1
            L 19, 0, 27, 30, cl, 1
            L 20, 0, 26, 30, cl, 1
            L 12, 5, 18, 10, cl, 2
            L 12, 20, 18, 25, cl, 2
         CASE 110   'normal, l(u)r(u)/l(d)r(d)
            L 0, 2, 30, 12, cl, 1
            L 0, 3, 30, 11, cl, 1
            L 0, 4, 30, 10, cl, 1
            L 0, 18, 30, 28, cl, 1
            L 0, 19, 30, 27, cl, 1
            L 0, 20, 30, 26, cl, 1
            L 5, 12, 10, 18, cl, 2
            L 20, 12, 25, 18, cl, 2
         CASE 111   'normal, u(l)d/u(r)d
            L 10, 20, 12, 30, cl, 2
            L 18, 20, 20, 30, cl, 2
            L 2, 0, 10, 20, cl, 0
            L 3, 0, 11, 20, cl, 0
            L 4, 0, 12, 20, cl, 0
            L 28, 0, 20, 20, cl, 0
            L 27, 0, 19, 20, cl, 0
            L 26, 0, 18, 20, cl, 0
            L 10, 0, 15, 13, cl, 0
            L 11, 0, 15, 10, cl, 0
            L 12, 0, 15, 7, cl, 0
            L 20, 0, 15, 13, cl, 0
            L 19, 0, 15, 10, cl, 0
            L 18, 0, 15, 7, cl, 0
         CASE 112   'normal, lr(u)/lr(d)
            L 10, 10, 0, 12, cl, 2
            L 10, 18, 0, 20, cl, 2
            L 30, 2, 10, 10, cl, 0
            L 30, 3, 10, 11, cl, 0
            L 30, 4, 10, 12, cl, 0
            L 30, 28, 10, 20, cl, 0
            L 30, 27, 10, 19, cl, 0
            L 30, 26, 10, 18, cl, 0
            L 30, 10, 17, 15, cl, 0
            L 30, 11, 20, 15, cl, 0
            L 30, 12, 23, 15, cl, 0
            L 30, 20, 17, 15, cl, 0
            L 30, 19, 20, 15, cl, 0
            L 30, 19, 23, 15, cl, 0
         CASE 113   'normal, ud(l)/ud(r)
            L 10, 10, 12, 0, cl, 2
            L 18, 10, 20, 0, cl, 2
            L 2, 30, 10, 10, cl, 0
            L 3, 30, 11, 10, cl, 0
            L 4, 30, 12, 10, cl, 0
            L 28, 30, 20, 10, cl, 0
            L 27, 30, 19, 10, cl, 0
            L 26, 30, 18, 10, cl, 0
            L 10, 30, 15, 17, cl, 0
            L 11, 30, 15, 20, cl, 0
            L 12, 30, 15, 23, cl, 0
            L 20, 30, 15, 17, cl, 0
            L 19, 30, 15, 20, cl, 0
            L 18, 30, 15, 23, cl, 0
         CASE 114   'normal, l(u)r/l(d)r
            L 20, 10, 30, 12, cl, 2
            L 20, 18, 30, 20, cl, 2
            L 0, 2, 20, 10, cl, 0
            L 0, 3, 20, 11, cl, 0
            L 0, 4, 20, 12, cl, 0
            L 0, 28, 20, 20, cl, 0
            L 0, 27, 20, 19, cl, 0
            L 0, 26, 20, 18, cl, 0
            L 0, 10, 13, 15, cl, 0
            L 0, 11, 10, 15, cl, 0
            L 0, 12, 7, 15, cl, 0
            L 0, 20, 13, 15, cl, 0
            L 0, 19, 10, 15, cl, 0
            L 0, 18, 7, 15, cl, 0
         CASE 115   'blocked, ud
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            L 10, 8, 15, 11, cl, 2
            L 15, 19, 20, 22, cl, 2
         CASE 116   'blocked, lr
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
            L 8, 20, 11, 15, cl, 2
            L 19, 10, 22, 15, cl, 2
         CASE 117   'high, U(l)d(l), 2*2
            L 0, 0, 10, 30, cl, 0
            L 1, 0, 11, 30, cl, 0
            L 2, 0, 12, 30, cl, 0
            L 10, 0, 20, 30, cl, 0
            L 10, 0, 19, 30, cl, 0
            L 10, 0, 18, 30, cl, 0
            FOR r = 0 TO 2
               C 30, 30, r + 10, cl, 0, 2 * pi, 1
               C 30, 30, r + 18, cl, pi, (2 * pi / 3) + (pi / 10), 1
            NEXT r
            L 10, 30, 10, 60, cl, 0
            L 11, 30, 11, 60, cl, 0
            L 12, 30, 12, 60, cl, 0
            L 20, 47, 20, 60, cl, 0
            L 19, 47, 19, 60, cl, 0
            L 18, 47, 18, 60, cl, 0
         CASE 118   'high, L(d)r(d), 2*2
            L 0, 30, 30, 40, cl, 0
            L 0, 31, 30, 41, cl, 0
            L 0, 32, 30, 42, cl, 0
            L 0, 40, 30, 50, cl, 0
            L 0, 40, 30, 49, cl, 0
            L 0, 40, 30, 48, cl, 0
            FOR r = 0 TO 2
               C 30, 30, r + 10, cl, 0, 2 * pi, 1
               C 30, 30, r + 18, cl, 3 * pi / 2, (7 * pi / 6) - (pi / 10), 1
            NEXT r
            L 30, 50, 60, 50, cl, 0
            L 30, 49, 60, 49, cl, 0
            L 30, 48, 60, 48, cl, 0
            L 47, 40, 60, 40, cl, 0
            L 47, 41, 60, 41, cl, 0
            L 47, 42, 60, 42, cl, 0
         CASE 119   'high, u(r)D(r), 2*2
            L 30, 60, 40, 40, cl, 0
            L 31, 60, 41, 30, cl, 0
            L 32, 60, 42, 30, cl, 0
            L 40, 60, 50, 30, cl, 0
            L 40, 60, 49, 30, cl, 0
            L 40, 60, 48, 30, cl, 0
            FOR r = 0 TO 2
               C 30, 30, r + 10, cl, 0, 2 * pi, 1
               C 30, 30, r + 18, cl, 0, (5 * pi / 3) - (pi / 10), 1
            NEXT r
            L 50, 30, 50, 0, cl, 0
            L 49, 30, 49, 0, cl, 0
            L 48, 30, 48, 0, cl, 0
            L 40, 13, 40, 0, cl, 0
            L 41, 13, 41, 0, cl, 0
            L 42, 13, 42, 0, cl, 0
         CASE 120   'high, l(u)R(u), 2*2
            L 30, 10, 60, 0, cl, 0
            L 30, 11, 60, 1, cl, 0
            L 30, 12, 60, 2, cl, 0
            L 30, 20, 60, 10, cl, 0
            L 30, 19, 60, 10, cl, 0
            L 30, 18, 60, 10, cl, 0
            FOR r = 0 TO 2
               C 30, 30, r + 10, cl, 0, 2 * pi, 1
               C 30, 30, r + 18, cl, pi / 2, (pi / 6) + (pi / 10), 1
            NEXT r
            L 30, 10, 0, 10, cl, 0
            L 30, 11, 0, 11, cl, 0
            L 30, 12, 0, 12, cl, 0
            L 13, 20, 0, 20, cl, 0
            L 13, 19, 0, 19, cl, 0
            L 13, 18, 0, 18, cl, 0
         CASE 121   'high, U(r)d(r), 2*2
            L 30, 0, 40, 30, cl, 0
            L 31, 0, 41, 30, cl, 0
            L 32, 0, 42, 30, cl, 0
            L 40, 0, 50, 30, cl, 0
            L 40, 0, 49, 30, cl, 0
            L 40, 0, 48, 30, cl, 0
            FOR r = 0 TO 2
               C 30, 30, r + 10, cl, 0, 2 * pi, 1
               C 30, 30, r + 18, cl, (pi / 3) + (pi / 10), 0, 1
            NEXT r
            L 50, 30, 50, 60, cl, 0
            L 49, 30, 49, 60, cl, 0
            L 48, 30, 48, 60, cl, 0
            L 40, 47, 40, 60, cl, 0
            L 41, 47, 41, 60, cl, 0
            L 42, 47, 42, 60, cl, 0
         CASE 122   'high, L(u)r(u), 2*2
            L 0, 0, 30, 10, cl, 0
            L 0, 1, 30, 11, cl, 0
            L 0, 2, 30, 12, cl, 0
            L 0, 10, 30, 20, cl, 0
            L 0, 10, 30, 19, cl, 0
            L 0, 10, 30, 18, cl, 0
            FOR r = 0 TO 2
               C 30, 30, r + 10, cl, 0, 2 * pi, 1
               C 30, 30, r + 18, cl, (5 * pi / 6) - (pi / 10), pi / 2, 1
            NEXT r
            L 30, 10, 60, 10, cl, 0
            L 30, 11, 60, 11, cl, 0
            L 30, 12, 60, 12, cl, 0
            L 47, 20, 60, 20, cl, 0
            L 47, 19, 60, 19, cl, 0
            L 47, 18, 60, 18, cl, 0
         CASE 123   'high, u(l)D(l), 2*2
            L 0, 60, 10, 30, cl, 0
            L 1, 60, 11, 30, cl, 0
            L 2, 60, 12, 30, cl, 0
            L 10, 60, 20, 30, cl, 0
            L 10, 60, 19, 30, cl, 0
            L 10, 60, 18, 30, cl, 0
            FOR r = 0 TO 2
               C 30, 30, r + 10, cl, 0, 2 * pi, 1
               C 30, 30, r + 18, cl, (4 * pi / 3) - (pi / 10), pi, 1
            NEXT r
            L 10, 30, 10, 0, cl, 0
            L 11, 30, 11, 0, cl, 0
            L 12, 30, 12, 0, cl, 0
            L 20, 13, 20, 0, cl, 0
            L 19, 13, 19, 0, cl, 0
            L 18, 13, 18, 0, cl, 0
         CASE 124   'high, l(d)R(d), 2*2
            L 60, 30, 30, 40, cl, 0
            L 60, 31, 30, 41, cl, 0
            L 60, 32, 30, 42, cl, 0
            L 60, 40, 30, 50, cl, 0
            L 60, 40, 30, 49, cl, 0
            L 60, 40, 30, 48, cl, 0
            FOR r = 0 TO 2
               C 30, 30, r + 10, cl, 0, 2 * pi, 1
               C 30, 30, r + 18, cl, (11 * pi / 6) + (pi / 10), 3 * pi / 2, 1
            NEXT r
            L 30, 50, 0, 50, cl, 0
            L 30, 49, 0, 49, cl, 0
            L 30, 48, 0, 48, cl, 0
            L 13, 40, 0, 40, cl, 0
            L 13, 41, 0, 41, cl, 0
            L 13, 42, 0, 42, cl, 0
         CASE 125   'mud, ud/lr
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
         CASE 126   'mud, ud/dl
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            C 0, 30, 20, cl, 0, .5 * pi, sq
            C 0, 30, 19, cl, 0, .5 * pi, sq
            C 0, 30, 10, cl, 0, .5 * pi, sq
            C 0, 30, 11, cl, 0, .5 * pi, sq
         CASE 127   'mud, lr/dr
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            C 30, 30, 20, cl, .5 * pi, pi, sq
            C 30, 30, 19, cl, .5 * pi, pi, sq
            C 30, 30, 10, cl, .5 * pi, pi, sq
            C 30, 30, 11, cl, .5 * pi, pi, sq
         CASE 128   'mud, ud/ur
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            C 30, 0, 20, cl, pi, 1.5 * pi, sq
            C 30, 0, 19, cl, pi, 1.5 * pi, sq
            C 30, 0, 10, cl, pi, 1.5 * pi, sq
            C 30, 0, 11, cl, pi, 1.5 * pi, sq
         CASE 129   'mud, lr/ul
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            C 0, 0, 20, cl, 1.5 * pi, 0, sq
            C 0, 0, 19, cl, 1.5 * pi, 0, sq
            C 0, 0, 10, cl, 1.5 * pi, 0, sq
            C 0, 0, 11, cl, 1.5 * pi, 0, sq
         CASE 130   'mud, ud/dr
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            C 30, 30, 20, cl, .5 * pi, pi, sq
            C 30, 30, 19, cl, .5 * pi, pi, sq
            C 30, 30, 10, cl, .5 * pi, pi, sq
            C 30, 30, 11, cl, .5 * pi, pi, sq
         CASE 131   'mud, lr/ur
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            C 30, 0, 20, cl, pi, 1.5 * pi, sq
            C 30, 0, 19, cl, pi, 1.5 * pi, sq
            C 30, 0, 10, cl, pi, 1.5 * pi, sq
            C 30, 0, 11, cl, pi, 1.5 * pi, sq
         CASE 132   'mud, ud/ul
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            C 0, 0, 20, cl, 1.5 * pi, 0, sq
            C 0, 0, 19, cl, 1.5 * pi, 0, sq
            C 0, 0, 10, cl, 1.5 * pi, 0, sq
            C 0, 0, 11, cl, 1.5 * pi, 0, sq
         CASE 133   'mud, lr/dl
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            C 0, 30, 20, cl, 0, .5 * pi, sq
            C 0, 30, 19, cl, 0, .5 * pi, sq
            C 0, 30, 10, cl, 0, .5 * pi, sq
            C 0, 30, 11, cl, 0, .5 * pi, sq
         CASE 134   'mud, -ud
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 5, 6, 25, 10, cl, 2
         CASE 135   'mud, u-d
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 5, 20, 25, 24, cl, 2
         CASE 136   'mud, l-r
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 20, 5, 24, 25, cl, 2
         CASE 137   'mud, -lr
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 6, 5, 10, 25, cl, 2
         CASE 138   'ice, ud/lr
            L 0, 10, 30, 20, cl, 1
            L 10, 0, 20, 30, cl, 1
         CASE 139   'ice, ud/dl
            L 10, 0, 20, 30, cl, 1
            C 0, 30, 20, cl, 0, .5 * pi, sq
            C 0, 30, 10, cl, 0, .5 * pi, sq
         CASE 140   'ice, lr/dr
            L 0, 10, 30, 20, cl, 1
            C 30, 30, 20, cl, .5 * pi, pi, sq
            C 30, 30, 10, cl, .5 * pi, pi, sq
         CASE 141   'ice, ud/ur
            L 10, 0, 20, 30, cl, 1
            C 30, 0, 20, cl, pi, 1.5 * pi, sq
            C 30, 0, 10, cl, pi, 1.5 * pi, sq
         CASE 142   'ice, lr/ul
            L 0, 10, 30, 20, cl, 1
            C 0, 0, 20, cl, 1.5 * pi, 0, sq
            C 0, 0, 10, cl, 1.5 * pi, 0, sq
         CASE 143   'ice, ud/dr
            L 10, 0, 20, 30, cl, 1
            C 30, 30, 20, cl, .5 * pi, pi, sq
            C 30, 30, 10, cl, .5 * pi, pi, sq
         CASE 144   'ice, lr/ur
            L 0, 10, 30, 20, cl, 1
            C 30, 0, 20, cl, pi, 1.5 * pi, sq
            C 30, 0, 10, cl, pi, 1.5 * pi, sq
         CASE 145   'ice, ud/ul
            L 10, 0, 20, 30, cl, 1
            C 0, 0, 20, cl, 1.5 * pi, 0, sq
            C 0, 0, 10, cl, 1.5 * pi, 0, sq
         CASE 146   'ice, lr,dl
            L 0, 10, 30, 20, cl, 1
            C 0, 30, 20, cl, 0, .5 * pi, sq
            C 0, 30, 10, cl, 0, .5 * pi, sq
         CASE 147   'ice, -ud
            L 10, 0, 20, 30, cl, 1
            L 5, 6, 25, 10, cl, 2
         CASE 148   'ice, u-d
            L 10, 0, 20, 30, cl, 1
            L 5, 20, 25, 24, cl, 2
         CASE 149   'ice, l-r
            L 0, 10, 30, 20, cl, 1
            L 20, 5, 24, 25, cl, 2
         CASE 150   'ice, -lr
            L 0, 10, 30, 20, cl, 1
            L 6, 5, 10, 25, cl, 2
         CASE 151   'tree, palm
            L 17, 25, 14, 5, cl, 0
            L 20, 24, 16, 5, cl, 0
            L 15, 4, 8, 10, cl, 0
            L 15, 4, 22, 9, cl, 0
         CASE 152   'tree, cactus
            L 14, 25, 16, 12, cl, 1
            L 14, 17, 10, 14, cl, 1
            L 16, 18, 19, 16, cl, 1
         CASE 153   'tree, fir
            L 13, 25, 17, 20, cl, 1
            L 6, 20, 24, 20, cl, 0
            L 6, 20, 15, 5, cl, 0
            L 15, 5, 24, 20, cl, 0
         CASE 154   'tennis court
            L 10, 25, 20, 5, cl, 1
            L 10, 15, 20, 15, cl, 0
         CASE 155   'petrol station, d
            L 5, 20, 25, 10, cl, 1
            L 8, 25, 10, 15, cl, 2
            L 20, 20, 23, 15, cl, 1
         CASE 156   'petrol station, u
            L 25, 10, 5, 20, cl, 1
            L 22, 5, 20, 15, cl, 2
            L 10, 10, 7, 15, cl, 1
         CASE 157   'petrol station, r
            L 20, 25, 10, 5, cl, 1
            L 25, 22, 15, 20, cl, 2
            L 20, 10, 15, 7, cl, 1
         CASE 158   'petrol station, l
            L 10, 5, 20, 25, cl, 1
            L 5, 8, 15, 10, cl, 2
            L 10, 20, 15, 23, cl, 1
         CASE 159   'x-barn, d
            L 10, 10, 20, 25, cl, 1
            L 10, 10, 15, 5, cl, 0
            L 20, 10, 15, 5, cl, 0
            C 15, 15, 5, cl, 0, 2 * pi, 1
         CASE 160   'x-barn, u
            L 10, 5, 20, 20, cl, 1
            L 10, 20, 15, 25, cl, 0
            L 20, 20, 15, 25, cl, 0
            C 15, 15, 5, cl, 0, 2 * pi, 1
         CASE 161   'x-barn, r
            L 10, 10, 25, 20, cl, 1
            L 10, 10, 5, 15, cl, 0
            L 10, 20, 5, 15, cl, 0
            C 15, 15, 5, cl, 0, 2 * pi, 1
         CASE 162    'x-barn,l
            L 5, 10, 20, 20, cl, 1
            L 20, 10, 25, 15, cl, 0
            L 20, 20, 25, 15, cl, 0
            C 15, 15, 5, cl, 0, 2 * pi, 1
         CASE 163   'skyscraper, d
            L 10, 25, 20, 5, cl, 1
            L 12, 25, 15, 20, cl, 2
         CASE 164   'skyscraper, u
            L 20, 5, 10, 25, cl, 1
            L 18, 5, 15, 10, cl, 2
         CASE 165   'skyscraper, r
            L 25, 20, 5, 10, cl, 1
            L 25, 18, 20, 15, cl, 2
         CASE 166   'skyscraper, l
            L 5, 10, 25, 20, cl, 1
            L 5, 12, 10, 15, cl, 2
         CASE 167   'windmill, d
            L 10, 25, 20, 15, cl, 2
            L 5, 20, 25, 0, cl, 0
            L 25, 20, 5, 0, cl, 0
         CASE 168   'windmill, u
            L 10, 5, 20, 15, cl, 2
            L 5, 10, 25, 30, cl, 0
            L 25, 10, 5, 30, cl, 0
         CASE 169   'windmill, r
            L 25, 10, 15, 20, cl, 2
            L 20, 5, 0, 25, cl, 0
            L 20, 25, 0, 5, cl, 0
         CASE 170   'windmill, l
            L 5, 10, 15, 20, cl, 2
            L 10, 5, 30, 25, cl, 0
            L 10, 25, 30, 5, cl, 0
         CASE 171   'ship, d
            L 12, 25, 30, 20, cl, 2
            L 6, 20, 30, 15, cl, 2
            L 20, 15, 24, 7, cl, 2
         CASE 172   'ship, u
            L 12, 5, 30, 10, cl, 2
            L 6, 10, 30, 15, cl, 2
            L 20, 15, 24, 23, cl, 2
         CASE 173   'ship, r
            L 25, 12, 20, 30, cl, 2
            L 20, 6, 15, 30, cl, 2
            L 15, 20, 7, 24, cl, 2
         CASE 174   'ship, l
            L 5, 12, 10, 30, cl, 2
            L 10, 6, 15, 30, cl, 2
            L 15, 20, 23, 24, cl, 2
         CASE 175   'house, d
            L 5, 25, 25, 15, cl, 2
            L 5, 15, 10, 5, cl, 0
            L 10, 5, 20, 5, cl, 0
            L 20, 5, 25, 15, cl, 0
         CASE 176   'house, u
            L 5, 5, 25, 15, cl, 2
            L 5, 15, 10, 25, cl, 0
            L 10, 25, 20, 25, cl, 0
            L 20, 25, 25, 15, cl, 0
         CASE 177   'house, r
            L 25, 5, 15, 25, cl, 2
            L 15, 5, 5, 10, cl, 0
            L 5, 10, 5, 20, cl, 0
            L 5, 20, 15, 25, cl, 0
         CASE 178   'house, l
            L 5, 5, 15, 25, cl, 2
            L 15, 5, 25, 10, cl, 0
            L 25, 10, 25, 20, cl, 0
            L 25, 20, 15, 25, cl, 0
         CASE 179   'normal, u-d
            L 10, 0, 20, 30, cl, 1
            L 11, 0, 19, 30, cl, 1
            L 12, 0, 18, 30, cl, 1
            L 5, 20, 25, 24, cl, 2
         CASE 180   'normal, l-r
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
            L 20, 5, 24, 25, cl, 2
         CASE 181   'normal, -lr
            L 0, 10, 30, 20, cl, 1
            L 0, 11, 30, 19, cl, 1
            L 0, 12, 30, 18, cl, 1
            L 6, 5, 10, 25, cl, 2
      END SELECT
   END IF
END SUB

SUB HelpScreen
   CLS
   PRINT "Welcome to the HELP SCREEN.  Press Y to quit."
   PRINT "This page lists all the active keys, the labelled ones, and their actions."
   PRINT "Press a key to bring up the action of that key."
   LINE (4, 88)-(35, 119), , B
   FOR a = 0 TO 2
      FOR b = 2 TO 5
         LINE (a * 144 + b * 32 + 4, 88)-(a * 144 + b * 32 + 35, 119), , B
      NEXT b
   NEXT a
   FOR a = 0 TO 12
      LINE (a * 32 + 4, 152)-(a * 32 + 35, 183), , B
   NEXT a
   FOR a = 1 TO 12
      LINE (a * 32 + 20, 184)-(a * 32 + 51, 215), , B
      LINE (a * 32 + 28, 216)-(a * 32 + 59, 247), , B
   NEXT a
   FOR a = 0 TO 11
      LINE (a * 32 + 4, 248)-(a * 32 + 35, 279), , B
   NEXT a
   LINE (4, 184)-(51, 215), , B: LINE (4, 216)-(43, 247), , B
   LINE (420, 152)-(483, 183), , B:
   LINE (388, 248)-(483, 279), , B: LINE (4, 280)-(51, 311), , B
   LINE (76, 280)-(123, 311), , B: LINE (124, 280)-(347, 311), , B
   LINE (348, 280)-(395, 311), , B: LINE (436, 280)-(483, 311), , B
   LINE (500, 280)-(595, 311), , B: LINE (532, 248)-(563, 311), , B
   LINE (436, 184)-(483, 184): LINE (483, 184)-(483, 247)
   LINE (483, 247)-(444, 247): LINE (444, 247)-(444, 215)
   LINE (444, 215)-(436, 215): LINE (436, 215)-(436, 184)
   a = 1
   WHILE locs(a, 2) <> 0
      LOCATE locs(a, 1), locs(a, 2)
      PRINT keys$(a);
      a = a + 1
   WEND
   i$ = UCASE$(INKEY$)
   WHILE i$ <> "Y"
      IF i$ <> "" THEN
         IF ASC(i$) = 0 THEN
            i = 1000 + ASC(RIGHT$(i$, 1))
         ELSE
            i = ASC(i$)
         END IF
         LOCATE 21, 1: PRINT SPACE$(80)
         LOCATE 21, 1: PRINT help$(i)
      END IF
      i$ = UCASE$(INKEY$)
   WEND
   PrintBar 1, "Press a key to leave help"
   WHILE INKEY$ = ""
   WEND
END SUB

SUB InverScen
   sav = 1
   CurOff
   SetFlag
   FOR a = x6 TO x5 STEP sg1
      FOR b = y6 TO y5 STEP sg2
         IF a >= 0 AND a <= 29 AND b >= 0 AND b <= 29 THEN
            tr(a, b) = inv(tr(a, b))
            ChangeScreen a, b, 0
         END IF
      NEXT b
   NEXT a
   CurOn
END SUB

SUB L (xa, ya, xb, yb, col, md)
   SELECT CASE md
      CASE 0
         LINE (x + s(xa), y + s(ya))-(x + s(xb), y + s(yb)), col
      CASE 1
         LINE (x + s(xa), y + s(ya))-(x + s(xb), y + s(yb)), col, B
      CASE 2
         LINE (x + s(xa), y + s(ya))-(x + s(xb), y + s(yb)), col, BF
   END SELECT
END SUB

SUB LaySelTrack
   sav = 1
   cv = ord(cur2, cur1)
   st = 0
   sd = sz(cv)
   IF sd MOD 4 > 1 THEN
      IF y5 = 29 THEN
         st = 1
      END IF
   END IF
   IF sd MOD 2 = 0 THEN
      IF x5 = 29 THEN
         st = 1
      END IF
   END IF
   IF st = 0 THEN
      DelTrack x5, y5
      IF sd = 2 THEN
         DelTrack x5 + 1, y5 + 1
      END IF
      IF sd MOD 2 = 0 THEN
         DelTrack x5 + 1, y5
      END IF
      IF sd MOD 4 > 1 THEN
         DelTrack x5, y5 + 1
      END IF
      ly(x5, y5) = cv
      IF sd = 2 THEN
         ly(x5 + 1, y5 + 1) = 253
      END IF
      IF sd MOD 2 = 0 THEN
         ly(x5 + 1, y5) = 255
      END IF
      IF sd MOD 4 > 1 THEN
         ly(x5, y5 + 1) = 254
      END IF
      DrawTrack x2 - 1, y2 - 1, cv, 0
   END IF
END SUB

SUB LowerScen
   sav = 1
   CurOff
   x5 = x2 + w3 - 1: y5 = y2 + h3 - 1
   x6 = x5 - 2: y6 = y5 - 2
   InverScen
   RaiseScen
   InverScen
   CurOn
END SUB

SUB P (xa, ya, col, bcol)
   PAINT (x + s(xa), y + s(ya)), col, bcol
END SUB

SUB PrintBar (dis, m$)
   LOCATE thei, dis
   PRINT m$;
END SUB

SUB PrintBox
   xa = 575
   ya = 0
   LINE (xa, ya)-(xa + 61, ya + 61), 0, BF
   LINE (xa, ya)-(xa + 61, ya + 61), , B
   LINE (xa + 2 * (w - 1), ya + 2 * (h - 1))-(xa + 2 * (wid + w - 1), ya + 2 * (height + h - 1)), 15, BF
END SUB

SUB PrintCol (row, m$)
   LOCATE row, twid
   PRINT m$;
END SUB

SUB PrintScreen
   CLS
   IF sc <> scst THEN
      scst = sc
      Scale sc
      h = 1
      w = 1
   END IF
   h3 = h
   w3 = w
   FOR a = 1 TO wid
      FOR d = 1 TO height
         x = s(30) * (a - 1)
         y = s(30) * (d - 1)
         L 0, 0, 30, 30, 15, 1
         DrawScen tr(a + w - 2, d + h - 2)
      NEXT d
   NEXT a
   FOR a = 1 TO wid
      FOR d = 1 TO height
         d2 = ly(a + w - 2, d + h - 2)
         IF d2 > 0 THEN
            DrawTrack a - 1, d - 1, d2, 0
         END IF
      NEXT d
   NEXT a
   DrawSelTrack
   CurOn
   PrintSel nord
   PrintBar hwid, "Press ESC for key help  "
   PrintBar fwid, in$
   PrintCol whei, " F5"
   PrintCol whei + 1, "Water"
   PrintCol whei + 2, wa$(wasz)
   PrintCol shei, " F6"
   PrintCol shei + 1, "Scale"
   PrintCol shei + 2, siz$(sc)
   PrintCol bhei, " F8"
   PrintCol bhei + 1, "Backdrop"
   PrintCol bhei + 2, bck$(back)
   PrintBox
END SUB

SUB PrintSel (n)
   nord = n
   PrintCol ahei, " SPACE"
   PrintCol ahei + 1, "AutoTrk"
   PrintCol ahei + 2, auto$(nord)
END SUB

SUB ProgramLoop
   WHILE 1 <> 0
      i$ = INKEY$
      WHILE i$ = ""
         i$ = INKEY$
      WEND
      i$ = UCASE$(i$)
      i = ASC(i$)
      IF i = 0 THEN
         i = 1000 + ASC(RIGHT$(i$, 1))
      END IF
      ftot = 0
      x2 = x1
      y2 = y1
      x5 = x2 + w3 - 2
      y5 = y2 + h3 - 2
      SELECT CASE i
         CASE 83
            IF y1 > 1 THEN
               y1 = y1 - 1
               CurOff
               CurOn
            END IF
         CASE 88
            IF y1 < height THEN
               y1 = y1 + 1
               CurOff
               CurOn
            END IF
         CASE 75
            IF x1 > 1 THEN
               x1 = x1 - 1
               CurOff
               CurOn
            END IF
         CASE 76
            IF x1 < wid THEN
               x1 = x1 + 1
               CurOff
               CurOn
            END IF
         CASE 1064
            sc = ((sc + 1) MOD 9)
            PrintCol shei + 2, siz$(sc)
         CASE 81
            Quit
         CASE 27
            HelpScreen
            PrintScreen
         CASE 65
            f = 0
            RaiseScen
            WHILE f <> 0 AND ftot < 10
               ftot = ftot + 1
               CurOff
               x1 = rec(f, 1)
               y1 = rec(f, 2)
               x2 = x1
               y2 = y1
               RaiseScen
               f = f - 1
            WEND
         CASE 1
            f = 0
            LowerScen
            WHILE f <> 0 AND ftot < 10
               ftot = ftot + 1
               CurOff
               x1 = rec(f, 1)
               y1 = rec(f, 2)
               x2 = x1
               y2 = y1
               LowerScen
               f = f - 1
            WEND
         CASE 86
            f = 0
            RaiseBlock
            WHILE f <> 0 AND ftot < 10
               ftot = ftot + 1
               CurOff
               x1 = rec(f, 1)
               y1 = rec(f, 2)
               x2 = x1
               y2 = y1
               RaiseScen
               f = f - 1
            WEND
         CASE 22
            f = 0
            RaiseLine
            WHILE f <> 0 AND ftot < 10
               ftot = ftot + 1
               CurOff
               x1 = rec(f, 1)
               y1 = rec(f, 2)
               x2 = x1
               y2 = y1
               RaiseScen
               f = f - 1
            WEND
         CASE 90
            DecScenNo
         CASE 68
            x6 = x5
            y6 = y5
         CASE 70
            x7 = x5
            y7 = y5
         CASE 67
            InverScen
         CASE 87
            SaveToFile
            PrintScreen
         CASE 1059
            ChangeScen 6
         CASE 1060
            ChangeScen 10
         CASE 1061
            ChangeScen 14
         CASE 1062
            ChangeScen 18
         CASE 49
            ChangeScen 1
         CASE 50
            ChangeScen 2
         CASE 51
            ChangeScen 3
         CASE 52
            ChangeScen 4
         CASE 53
            ChangeScen 5
         CASE 1063
            wasz = (wasz + 1) MOD 3
            PrintCol whei + 2, wa$(wasz)
         CASE 5
            WaterScenD
         CASE 69
            WaterScenN
         CASE 92
            Water
         CASE 18
            WaterLine
         CASE 82
            WaterBlock
         CASE 1080
            IF h < 31 - height THEN
               h = h + 1
               PrintBox
            END IF
         CASE 1072
            IF h > 1 THEN
               h = h - 1
               PrintBox
            END IF
         CASE 1075
            IF w > 1 THEN
               w = w - 1
               PrintBox
            END IF
         CASE 1077
            IF w < 31 - wid THEN
               w = w + 1
               PrintBox
            END IF
         CASE 1066
            sav = 1
            back = (back + 1) MOD 5
            PrintCol bhei + 2, bck$(back)
         CASE 1067
            PrintSel 1
         CASE 1068
            PrintSel 2
         CASE 1133
            PrintSel 3
         CASE 1134
            PrintSel 4
         CASE 32
            PrintSel ((nord MOD 4) + 1)
         CASE 44
            AutoTrack
         CASE 46
            SWAP nord, enord
            AutoTrack
            SWAP nord, enord
         CASE 79
            cur1 = cur1 - 1
            DrawSelTrack
         CASE 80
            cur1 = cur1 + 1
            DrawSelTrack
         CASE 59
            LaySelTrack
         CASE 91
            cur1 = 1
            cur2 = cur2 + 1
            DrawSelTrack
         CASE 73
            cur1 = 1
            cur2 = cur2 - 1
            DrawSelTrack
         CASE 47
            DelTrack x5, y5
         CASE 84
            AbandonFile
            ReadFile
            PrintScreen
         CASE 13
            PrintScreen
      END SELECT
      PrintBar lwid, alt$(sav)
   WEND
END SUB

SUB Quit
   AbandonFile
   PrintBar hwid, "Really want to quit? (Y)   "
   i$ = INKEY$
   WHILE i$ = ""
      i$ = INKEY$
   WEND
   PrintBar hwid, "Press ESC for key help  "
   IF i$ = "Y" THEN END
END SUB

SUB RaiseBlock
   sav = 1
   CurOff
   SetFlag
   FOR a = x6 TO x5 STEP sg1
      Combine a, y6 - sg2, 8 + sg2
      Combine a, y5 + sg2, 8 - sg2
      FOR b = y6 TO y5 STEP sg2
         tr(a, b) = 6
         ChangeScreen a, b, 0
      NEXT b
   NEXT a
   FOR b = y6 TO y5 STEP sg2
      Combine x6 - sg1, b, 9 + sg1
      Combine x5 + sg1, b, 9 - sg1
   NEXT b
   Combine x6 - sg1, y6 - sg2, 12.5 + sg1 - (.5 * sg1 * sg2)
   Combine x5 + sg1, y5 + sg2, 12.5 - sg1 - (.5 * sg1 * sg2)
   Combine x6 - sg1, y5 + sg2, 12.5 + sg1 + (.5 * sg1 * sg2)
   Combine x5 + sg1, y6 - sg2, 12.5 - sg1 + (.5 * sg1 * sg2)
   CurOn
END SUB

SUB RaiseLine
   sav = 1
   SetFlag
   CurOff
   IF xflg * yflg = 1 THEN
      RaiseScen
   ELSE
      IF ABS(x5 - x6) > ABS(y5 - y6) THEN
         ym = (y5 - y6) / (x5 - x6)
         FOR a = x6 TO x5 STEP sg1
            x1 = a - w3 + 2
            y1 = y6 + INT((a - x6) * ym) - h3 + 2
            x2 = x1
            y2 = y1
            RaiseScen
         NEXT a
      ELSE
         xm = (x5 - x6) / (y5 - y6)
         FOR b = y6 TO y5 STEP sg2
            x1 = x6 + INT((b - y6) * xm) - w3 + 2
            y1 = b - h3 + 2
            x2 = x1
            y2 = y1
            RaiseScen
         NEXT b
      END IF
   END IF
   CurOn
END SUB

SUB RaiseScen
   sav = 1
   CurOff
   x4 = x1 + w3 - 2
   y4 = y1 + h3 - 2
   Combine x4, y4, 6
   Combine x4 + 1, y4, 8
   Combine x4 + 1, y4 + 1, 11
   Combine x4, y4 + 1, 7
   Combine x4 - 1, y4 + 1, 14
   Combine x4 - 1, y4, 10
   Combine x4 - 1, y4 - 1, 13
   Combine x4, y4 - 1, 9
   Combine x4 + 1, y4 - 1, 12
   CurOn
END SUB

SUB ReadData
   LOCATE csr, 1
   PRINT "Please wait, loading data."
   FOR a = 0 TO 1
      READ alt$(a)
   NEXT
   FOR a = 0 TO 8
      FOR b = 0 TO 30
         READ ss(a, b)
      NEXT b
   NEXT a
   FOR a = 0 TO 8
      READ siz$(a)
   NEXT a
   FOR a = 0 TO 18
      LOCATE 2, 70
      PRINT INT(a * 5);
      LOCATE 2, 74
      PRINT "%";
      FOR b = 0 TO 18
         info(b, a) = 19
      NEXT b
   NEXT a
   FOR r = 1 TO cr
      READ a, d, info(a, d)
      info(d, a) = info(a, d)
   NEXT r
   FOR a = 0 TO 19
      READ inv(a)
   NEXT a
   FOR a = 1 TO 5
      FOR d = 1 TO 16
         READ rd(a, d)
      NEXT d
   NEXT a
   FOR a = 0 TO 181
      READ sz(a)
   NEXT a
   LOCATE 2, 71
   PRINT "100%";
   FOR a = 1 TO 4
      READ auto$(a)
   NEXT a
   FOR a = 0 TO 2
      READ wa$(a)
   NEXT a
   FOR a = 0 TO 4
      READ bck$(a)
   NEXT a
   FOR a = 1 TO 12
      READ nm$(a)
      READ d
      ord(a, 0) = d
      FOR b = 1 TO d
         READ ord(a, b)
      NEXT b
   NEXT a
   READ b
   WHILE b <> 0
      READ help$(b)
      READ b
   WEND
   a = 1
   READ locs(a, 2)
   WHILE locs(a, 2) <> 0
      READ locs(a, 1), keys$(a)
      a = a + 1
      READ locs(a, 2)
   WEND
END SUB

SUB ReadFile
   CLS
   SCREEN 12
   PRINT "Welcome to The Track Editor, version 19, by Tim Granger."
   INPUT "Please enter your 4d directory, default = C:\GAMES\4D\  :", direc$
   IF direc$ = "" THEN
      direc$ = "C:\GAMES\4D\"
   END IF
   FILES direc$ + "*.trk"
   INPUT "Enter input file, 'filename'.trk, default = BLANK  :", in$
   IF in$ = "" THEN
      in$ = "BLANK"
   END IF
   in$ = direc$ + UCASE$(in$) + ".TRK"
   PRINT "Please wait, loading file."
   csr = CSRLIN
   OPEN "B", #1, in$, 1802
   d$ = " "
   FOR a = 0 TO 29
      LOCATE 1, 70
      PRINT INT(a / 6 * 10);
      LOCATE 1, 74
      PRINT "%";
      FOR d = 0 TO 29
         e = 1 + d + (30 * a)
         GET #1, e, d$
         ly(d, 29 - a) = ASC(d$)
      NEXT d
   NEXT a
   FOR a = 0 TO 29
      LOCATE 1, 70
      PRINT INT((a + 30) / 6 * 10);
      LOCATE 1, 74
      PRINT "%";
      FOR d = 0 TO 29
         e = 902 + d + (30 * a)
         GET #1, e, d$
         tr(d, a) = ASC(d$)
      NEXT d
   NEXT a
   LOCATE 1, 70
   PRINT " 100%"
   GET #1, 901, d$
   back = ASC(d$)
   GET #1, 1802, d$
   CLOSE #1
   sav = 0
END SUB

SUB SaveToFile
   CLS
   FILES direc$ + "*.trk"
   LINE INPUT "Enter output file (RETURN to cancel) (* for input file):", out$
   out$ = UCASE$(out$)
   IF out$ <> "" THEN
      PRINT "Please wait, saving file."
      IF out$ <> "*" THEN
         in$ = direc$ + out$ + ".TRK"
      END IF
      OPEN "B", #1, in$, 1802
      FOR a = 0 TO 29
         LOCATE 1, 70
         PRINT INT(a / 6 * 10);
         LOCATE 1, 74
         PRINT "%";
         FOR b = 0 TO 29
            d$ = CHR$(ly(b, 29 - a))
            PUT #1, 30 * a + b + 1, d$
         NEXT b
      NEXT a
      FOR a = 0 TO 29
         LOCATE 1, 70
         PRINT INT((a + 30) / 6 * 10);
         LOCATE 1, 74
         PRINT "%";
         FOR b = 0 TO 29
            d = 902 + b + (30 * a)
            d$ = CHR$(tr(b, a))
            PUT #1, d, d$
         NEXT b
      NEXT a
      LOCATE 1, 70
      PRINT " 100%"
      sav = 0
      d$ = CHR$(back)
      PUT #1, 901, d$
      d$ = CHR$(0)
      PUT #1, 1802, d$
      CLOSE #1
   END IF
END SUB

SUB Scale (scl)
   sc = scl
   height = INT(450 / ss(sc, 30))
   wid = INT(570 / ss(sc, 30))
   IF height > 30 THEN
      height = 30
   END IF
   IF wid > 30 THEN
      wid = 30
   END IF
   FOR a = 0 TO 30
      s(a) = ss(sc, a)
      s(a + 30) = ss(sc, a) + ss(sc, 30)
      s(a + 100) = -ss(sc, a)
      s(a + 130) = -ss(sc, a) - ss(sc, 30)
   NEXT a
END SUB

FUNCTION ScreenCheck (xa, ya)
   ScreenCheck = -1
   IF x < 0 OR y < 0 OR y + 1 > s(30) * (height - xa) OR x + 1 > s(30) * (wid - ya) THEN
      ScreenCheck = 0
   END IF
END FUNCTION

SUB SetFlag
   sg1 = SGN(x5 - x6)
   sg2 = SGN(y5 - y6)
   xflg = 0
   yflg = 0
   IF sg1 = 0 THEN
      xflg = 1
      sg1 = 1
   END IF
   IF sg2 = 0 THEN
      yflg = 1
      sg2 = 1
   END IF
END SUB

SUB Water
   sav = 1
   CurOff
   x4 = x1 + w3 - 2
   y4 = y1 + h3 - 2
   SELECT CASE wasz
      CASE 2
         Combine x4, y4, 1
         Combine x4 + 1, y4, 1
         Combine x4 + 1, y4 + 1, 5
         Combine x4, y4 + 1, 1
         Combine x4 - 1, y4 + 1, 4
         Combine x4 - 1, y4, 1
         Combine x4 - 1, y4 - 1, 3
         Combine x4, y4 - 1, 1
         Combine x4 + 1, y4 - 1, 2
      CASE 1
         Combine x4, y4, 3
         Combine x4 + 1, y4, 2
         Combine x4, y4 + 1, 4
         Combine x4 + 1, y4 + 1, 5
      CASE 0
         Combine x4, y4, 1
   END SELECT
   CurOn
END SUB

SUB WaterBlock
   sav = 1
   CurOff
   SetFlag
   FOR a = x6 TO x5 STEP sg1
      FOR b = y6 TO y5 STEP sg2
         tr(a, b) = 1
         IF a = x6 THEN
            IF b = y6 THEN
               tr(a, b) = 3.5 - sg2 + .5 * (sg1 * sg2)
            ELSEIF b = y5 THEN
               tr(a, b) = 3.5 + sg2 - .5 * (sg1 * sg2)
            END IF
         ELSEIF a = x5 THEN
            IF b = y6 THEN
               tr(a, b) = 3.5 - sg2 - .5 * (sg1 * sg2)
            ELSEIF b = y5 THEN
               tr(a, b) = 3.5 + sg2 + .5 * (sg1 * sg2)
            END IF
         END IF
         ChangeScreen a, b, 0
      NEXT b
   NEXT a
   CurOn
END SUB

SUB WaterLine
   sav = 1
   SetFlag
   CurOff
   IF xflg * yflg = 1 THEN
      Water
   ELSE
      IF ABS(x5 - x6) > ABS(y5 - y6) THEN
         ym = (y5 - y6) / (x5 - x6)
         FOR a = x6 TO x5 STEP sg1
            x1 = a - w3 + 2
            y1 = y6 + INT((a - x6) * ym) - h3 + 2
            x2 = x1
            y2 = y1
            Water
            CurOff
         NEXT a
      ELSE
         xm = (x5 - x6) / (y5 - y6)
         FOR b = y6 TO y5 STEP sg2
            x1 = x6 + INT((b - y6) * xm) - w3 + 2
            y1 = b - h3 + 2
            x2 = x1
            y2 = y1
            Water
            CurOff
         NEXT b
      END IF
   END IF
   CurOn
END SUB

SUB WaterScenD
   sav = 1
   CurOff
   SetFlag
   FOR a = x6 TO x5 STEP sg1
      FOR b = y6 TO y5 STEP sg2
         tr(a, b) = 1
         ChangeScreen a, b, 0
      NEXT b
   NEXT a
   CurOn
END SUB

SUB WaterScenN
   sav = 1
   CurOff
   SetFlag
   FOR a = x6 TO x5 STEP sg1
      FOR b = y6 TO y5 STEP sg2
         al = -1
         SELECT CASE tr(a, b)
         CASE 0
            al = 1
         CASE 1
            al = 0
         CASE 2
            al = 4
         CASE 3
            al = 5
         CASE 4
            al = 2
         CASE 5
            al = 3
         END SELECT
         IF al <> -1 THEN
            tr(a, b) = al
         END IF
         ChangeScreen a, b, 0
         NEXT b
   NEXT a
   CurOn
END SUB

